# Loraine.jl

*Sweet Lor(r)aine, let the party carry on[^1]...*

[^1]: https://www.youtube.com/watch?v=0D2wNf1lVrI

Loraine.jl is a Julia implementation of an interior point method algorithm for
linear semidefinite optimization problems. 

Special features of Loraine:

- Use of an iterative solver for linear systems. This is to be used for problems with (very) low rank solution matrix. Standard (non-low-rank) problems and linear programs can be solved using the direct solver; then the user gets a standard IP method akin SDPT3.
- Use of high-precision arithmetic (by means of MultiFloats.jl). Only to be used with a direct solver (and relatively small problems). *(New in version 0.2.0.)*

There is also a MATLAB version of the code at [kocvara/Loraine.m](https://github.com/kocvara/Loraine.m).

## License and Original Contributors

Loraine is licensed under the [MIT License](https://github.com/kocvara/Loraine.jl/blob/main/LICENSE.md).

Loraine was developed by Soodeh Habibi and Michal Kočvara, University of
Birmingham, and Michael Stingl, University of Erlangen, for H2020 ITN POEMA. 

The JuMP interface was provided by Benoît Legat. His help is greatly
acknowledged.

## Installation 

Install `Loraine` using `Pkg.add`:
```julia
import Pkg
Pkg.add("Loraine")
```

## Use with JuMP

To use Loraine with JuMP, use `Loraine.Optimizer` (for a standard double-precision solver) or `Loraine.Optimizer{Float64xN}`, with N = 2,...,8 ; for instance:
```julia
using JuMP, Loraine
model = Model(Loraine.Optimizer)
set_attribute(model, "maxit", 100)
```
or, for high-precision arithmetics,
```julia
using JuMP, Loraine
using MultiFloats
model = Model(Loraine.Optimizer{Float64x2})
```
or, for high-precision arithmetics with high-precision input,
```julia
using JuMP, Loraine
using MultiFloats
model = JuMP.GenericModel{Float64x2}(Loraine.Optimizer{Float64x2})
```
To solve an SDP problem stored in SDPA format, do
```julia
using JuMP, Loraine
# using MultiFloats
model = read_from_file("examples/data/theta1.dat-s")
set_optimizer(model, Loraine.Optimizer)
# set_optimizer(model, Loraine.Optimizer{Float64x8})
optimize!(model)
```

For more examples, the folder [`examples`](https://github.com/kocvara/Loraine.jl/tree/main/examples)
includes a few examples of how to use Loraine via JuMP; in particular,
`solve_sdpa.jl` reads an SDP in the SDPA input format and solves it by Loraine.
A few sample problems can be found in folder `examples/data`.

## Rank-one data
If the solution does not have low rank, it is recommended to use a direct 
solver `kit = 0`. However, if you know that your data matrices are all rank-one, 
use the option `datarank = -1` to get a significant reduction in the complexity 
(and CPU time). Examples of such problems are `maxG11` and `thetaG11` from the 
`SDPLIB` collection.

## Documentation
[Loraine documentation](https://kocvara.github.io/Loraine.jl/)

## Options

The list of options:
```julia
kit             # kit = 0 for direct solver; kit = 1 for CG [0]
tol_cg          # tolerance for CG solver [1.0e-2]
tol_cg_up       # tolerance update [0.5]
tol_cg_min      # minimal tolerance for CG solver [1.0e-6]
eDIMACS         # epsilon for DIMACS error stopping criterion [1.0e-5]
preconditioner  # 0...no; 1...H_alpha; 2...H_beta; 4...hybrid [1]
erank           # estimated rank [1]
aamat           # 0..A^TA; 1..diag(A^TA); 2..identity [2]
verb            # 2..full output; 1..short output; 0..no output [1]
datarank        # 0..full rank matrices expected [0]
                # -1..rank-1 matrices expected, converted to vectors, if possible
                # (TBD) 1..vectors expected for low-rank data matrices
initpoint       # 0..Loraine heuristics, 1..SDPT3-like heuristics [0]
timing          # 1..yes, 0..no
maxit           # maximal number of global iterations [200]
datasparsity    # data matrices treated as sparse when number of their 
                # non-zero elements is below this parameter [8]
```

## Citing

If you find Loraine useful, please cite the following paper:
```bibtex
@article{loraine2023,
  title={Loraine-An interior-point solver for low-rank semidefinite programming},
  author={Habibi, Soodeh and Ko{\v{c}}vara, Michal and Stingl, Michael},
  www={https://hal.science/hal-04076509/}
  note={Preprint hal-04076509}
  year={2023}
}
```

function initial_point(solver)

   find_initial!(solver)

    solver.sigma = 3

    # These two parameters may influence convergence:
    solver.tau = 0.95  #lower value; such as 0.9 leads to more iterations but more robust algo
    solver.expon = 3.0

    solver.DIMACS_error = 1.0
    solver.iter = 0
    solver.status = 0 

end

function  find_initial!(solver)

    C_lin = solver.model.C_lin'
    
    n = length(solver.model.b)
    solver.y = zeros(eltype(eltype(solver.X)), n)

    b2 = @. 1 + abs(solver.model.b)
    f = 0.0
    for i=1:solver.model.nlmi
        if solver.initpoint == 0
            Eps = 1.0
        else
            f = norm(b2)/(1+norm(solver.model.AA[i]))
            Eps = sqrt.(solver.model.msizes[i]).* max(1,sqrt.(solver.model.msizes[i]).* f)
        end
        solver.X[i] = Eps * Matrix(1.0I, Int64(solver.model.msizes[i]), Int64(solver.model.msizes[i]))
        
        if solver.initpoint == 0
            Eta = solver.model.n
        else
            mf = max(f,norm(solver.model.C[i],2))
            mf = (1 + mf)./ sqrt(solver.model.msizes[i])
            Eta = sqrt(solver.model.msizes[i]).* max(1,mf)
        end
        solver.S[i] = Eta * Matrix(1.0I, Int64(solver.model.msizes[i]), Int64(solver.model.msizes[i]))
    end
    
    p = zeros(n)
    pp = zeros(n)
    dd = size(solver.model.d_lin,1)
    if solver.model.nlin>0
        if solver.initpoint == 0
            Epss = 1.0
        else
            for j=1:n
                normClin = 1+norm(solver.model.C_lin[j,:])
                p[j] = b2[j] ./ normClin;
            end
            Epss = max(1, maximum(p))
        end
        solver.X_lin = fill(Epss, dd)
        
        if solver.initpoint == 0
            Etaa = 1.0
        else
            for j=1:n
                pp[j]=norm(solver.model.C_lin[j,:])
            end
            mf = max(maximum(pp),norm(solver.model.d_lin))
            mf = (0 + mf) ./ sqrt(dd)
            Etaa =  max(1,mf)
        end
        solver.S_lin = fill(Etaa, dd)
        solver.S_lin_inv = 1 ./ solver.S_lin
    else
        solver.X_lin = Float64[]; solver.S_lin = Float64[]
    end
    if solver.model.nlin==0
        solver.X_lin=Float64[]
        solver.S_lin=Float64[]
        solver.S_lin_inv=Float64[]
    end
    
end

using JuMP
import LinearAlgebra
# import SCS
import Loraine
import Test

function example_correlation_problem()
    model = Model(Loraine.Optimizer)
    set_silent(model)
    MOI.set(model, MOI.RawOptimizerAttribute("kit"), 0)
    @variable(model, X[1:3, 1:3], PSD)
    S = ["A", "B", "C"]
    ρ = Containers.DenseAxisArray(X, S, S)
    @constraint(model, [i in S], ρ[i, i] == 1)
    @constraint(model, -0.2 <= ρ["A", "B"] <= -0.1)
    @constraint(model, 0.4 <= ρ["B", "C"] <= 0.5)
    @objective(model, Max, ρ["A", "C"])
    
    optimize!(model)
    upper = value(ρ["A", "C"])
    println("An upper bound for ρ_AC is $upper")
    @objective(model, Min, ρ["A", "C"])
    optimize!(model)
    lower = value(ρ["A", "C"])
    println("A lower bound for ρ_AC is $lower")
    return lower, upper
end

lower, upper = example_correlation_problem()
@test lower ≈ -0.9779977649 rtol = 1e-6
@test upper ≈  0.8719210472 rtol = 1e-6

function makeBBBB_rank1(n,nlmi,B,G,to)
    @timeit to "BBBB_rank1" begin
    BBBB = zeros(Float64, n, n)
    tmp = zeros(Float64, n, n)
    for ilmi = 1:nlmi
        BB = transpose(B[ilmi] * G[ilmi])
        mul!(tmp, BB', BB)
        @. BBBB += tmp * tmp
    end
    end
    return BBBB
end

#########################

function makeBBBBs(n,nlmi,A,AA,W,to,qA,sigmaA)
    T = eltype(eltype(W))
    BBBB = zeros(T, n, n)
    @inbounds for ilmi = 1:nlmi
        Wilmi = W[ilmi]
        AAilmi = AA[ilmi]
        Ailmi = A[ilmi,:]
        @timeit to "BBBBs" begin
        makeBBBBsi!(BBBB,ilmi,Ailmi,AAilmi,Wilmi,n,to,qA,sigmaA)
        end
    end

    return BBBB
end

# Computes `⟨A * W, W * B⟩` for symmetric sparse matrices `A` and `B`
function _dot(A::SparseMatrixCSC, B::SparseMatrixCSC, W::Matrix)
    @assert LinearAlgebra.checksquare(W) == LinearAlgebra.checksquare(A) == LinearAlgebra.checksquare(B)
    # After these asserts, we know that `A`, `B` and `W` are square and
    # have the same sizes so we can safely use `@inbounds`
    result = zero(eltype(A))
    @inbounds for i in axes(A, 2)
        nzA = nzrange(A, i)
        if !isempty(nzA)
            for j in axes(B, 2)
                nzB = nzrange(B, j)
                if !isempty(nzB)
                    AW = zero(result)
                    for k in nzA
                        AW += nonzeros(A)[k] * W[rowvals(A)[k], j]
                    end
                    WB = zero(result)
                    for k in nzB
                        WB += W[i, rowvals(B)[k]] * nonzeros(B)[k]
                    end
                    result += AW * WB
                end
            end
        end
    end
    return result
end

#####
function makeBBBBsi!(BBBB,ilmi,Ailmi,AAilmi,Wilmi::Matrix{T},n,to,qA,sigmaA) where {T}
    m = size(Wilmi, 1)
    tmp1 = Matrix{T}(undef, m, m)
    tmp_mat = Matrix{T}(undef, m, m)
    tmp2 = Vector{T}(undef, size(AAilmi, 1))

    @inbounds for ii = 1:n
        i = sigmaA[ii,ilmi]
        if nnz(Ailmi[i+1]) > 0
            if ii <= qA[1,ilmi]
                @timeit to "BBBBone" begin
                    @timeit to "BBBBone1" begin
                        mul!(tmp1,Wilmi,Ailmi[i+1])
                    end
                    @timeit to "BBBBone2" begin
                        mul!(tmp_mat,tmp1,Wilmi)
                    end
                    @timeit to "BBBBone3" begin
                        mul!(tmp2,AAilmi,vec(tmp_mat))
                    end
                    @timeit to "BBBBone4" begin
                        indi = @view sigmaA[ii:end,ilmi]
                        @inbounds for k in indi
                            v = -tmp2[k]
                            BBBB[k,i] += v
                            if k != i
                                BBBB[i,k] += v
                            end
                        end
                    end
                end
            elseif 1==0
                @timeit to "BBBBtwo" begin
                mul!(tmp1,Ailmi[i+1],Wilmi)
                @inbounds for jj = ii:n
                    j = sigmaA[jj,ilmi]
                    Ajjj = Ailmi[j+1]
                    if !iszero(nnz(Ajjj))
                        ttt = 0.0
                        @inbounds for jjjjAj in axes(Ajjj, 2)
                            for k in nzrange(Ajjj, jjjjAj)
                                iiijAj = rowvals(Ajjj)[k]
                                ttt1 = dot(tmp1[:,iiijAj],Wilmi[:,jjjjAj])
                                ttt += ttt1 * nonzeros(Ajjj)[k]
                            end
                        end
                        BBBB[i,j] += ttt
                        if !=(i,j)
                            BBBB[j,i] += ttt
                        end
                    end
                end
                end
            else
                @timeit to "BBBBthree" begin
                if !iszero(nnz(Ailmi[i+1]))
                    if nnz(Ailmi[i+1]) > 1
                        @inbounds for jj = ii:n
                            j = sigmaA[jj,ilmi]
                            if !iszero(nnz(Ailmi[j+1]))
                                ttt = _dot(Ailmi[i+1], Ailmi[j+1], Wilmi)
                                if i >= j
                                    BBBB[i,j] += ttt
                                else
                                    BBBB[j,i] += ttt
                                end
                            end
                        end
                    else
                        @timeit to "BBBBthree=1" begin
                        # A is symmetric
                        iiiiAi = jjjiAi = only(rowvals(Ailmi[i+1]))
                        vvvi = only(nonzeros(Ailmi[i+1]))
                        @inbounds for jj = ii:n
                            j = sigmaA[jj,ilmi]
                            Ajjj = Ailmi[j+1]
                            # As we sort the matrices in decreasing `nnz` order,
                            # the rest of matrices is either zero or have only
                            # one entry
                            if !iszero(nnz(Ajjj))
                                iiijAj = jjjjAj = only(rowvals(Ajjj))
                                vvvj = only(nonzeros(Ajjj))
                                ttt = vvvi * Wilmi[iiiiAi,iiijAj] * Wilmi[jjjiAi,jjjjAj] * vvvj
                                if i >= j
                                    BBBB[i,j] += ttt
                                else
                                    BBBB[j,i] += ttt
                                end
                            end
                        end
                        end
                    end
                end
                end
            end
        end
    end
end


function makeRHS(nlmi,AA,W,S,Rp,Rd)
    h = copy(Rp)
    for i = 1:nlmi
        tmp = W[i]*(Rd[i]+S[i])*W[i]
        mul!(h, AA[i], vec(tmp), true, true)
    end
    return h
end

# Merge two benchmark CSVs (e.g. one from `main`, one from `nlpmodel`) produced
# by `benchmark_sdplib.jl`, and print a GitHub-ready markdown comparison table.
#
# Needs CSV.jl and DataFrames.jl. Run in an environment that has them, e.g.:
#
#     julia --project=@bench examples/merge_results.jl results_main.csv results_nlpmodel.csv
#
# (where `@bench` is any env with `CSV` and `DataFrames` added).
#
# Args: [1] baseline CSV (e.g. main), [2] comparison CSV (e.g. nlpmodel).
# The column labels are taken from each CSV's `label` field.

using CSV
using DataFrames
import Printf

function load(path)
    df = CSV.read(path, DataFrame)
    return df, isempty(df.label) ? basename(path) : first(df.label)
end

function fmt_time(t)
    (ismissing(t) || !isfinite(t)) && return "—"
    return Printf.@sprintf("%.3f", t)
end

function fmt_speedup(s)
    (ismissing(s) || !isfinite(s)) && return "—"
    return Printf.@sprintf("%.2f×", s)
end

function fmt_obj(o)
    (ismissing(o) || !isfinite(o)) && return "—"
    return Printf.@sprintf("%.6g", o)
end

function fmt_int(i)
    (ismissing(i) || i < 0) && return "—" # `-1` marks TIMEOUT/ERROR rows
    return string(i)
end

function merge(baseline = ARGS[1], comparison = ARGS[2])
    base, base_label = load(baseline)
    comp, comp_label = load(comparison)

    # Compare on `time_s`: the robust (Chairmarks minimum) warm-solve time,
    # free of compilation and one-shot noise.
    a = select(
        base,
        :problem,
        :n,
        :m,
        :time_s => :t_base,
        :iterations => :it_base,
        :objective => :obj_base,
        :status => :st_base,
    )
    b = select(
        comp,
        :problem,
        :time_s => :t_comp,
        :iterations => :it_comp,
        :objective => :obj_comp,
        :status => :st_comp,
    )
    df = outerjoin(a, b, on = :problem)
    df.speedup = df.t_base ./ df.t_comp
    sort!(df, [:speedup])

    # --- markdown table ---
    header = "| problem | n | m | $base_label (s) | $comp_label (s) | speedup | it $base_label | it $comp_label | obj $base_label | obj $comp_label |"
    sep = "| --- | ---: | ---: | ---: | ---: | ---: | ---: | ---: | ---: | ---: |"
    println(header)
    println(sep)
    for r in eachrow(df)
        println(
            "| ",
            r.problem,
            " | ",
            ismissing(r.n) ? "—" : r.n,
            " | ",
            ismissing(r.m) ? "—" : r.m,
            " | ",
            fmt_time(r.t_base),
            " | ",
            fmt_time(r.t_comp),
            " | ",
            fmt_speedup(r.speedup),
            " | ",
            fmt_int(r.it_base),
            " | ",
            fmt_int(r.it_comp),
            " | ",
            fmt_obj(r.obj_base),
            " | ",
            fmt_obj(r.obj_comp),
            " |",
        )
    end

    # --- summary over problems with a real solve time on both sides ---
    # (drops `missing` from the join and `NaN` from TIMEOUT/ERROR rows)
    isfin(x) = !ismissing(x) && isfinite(x)
    both = filter(row -> isfin(row.t_base) && isfin(row.t_comp), df)
    tot_base = sum(both.t_base)
    tot_comp = sum(both.t_comp)
    geo = isempty(both.speedup) ? NaN :
          exp(sum(log, both.speedup) / nrow(both))
    println()
    println(
        "**",
        nrow(both),
        " problems solved by both** — total time: ",
        fmt_time(tot_base),
        "s ($base_label) vs ",
        fmt_time(tot_comp),
        "s ($comp_label); overall ",
        fmt_speedup(tot_base / tot_comp),
        ", geometric-mean per-problem ",
        fmt_speedup(geo),
        ".",
    )
end

#=
Copyright (c) 2023 Soodeh Habibi, Michal Kocvara, Michael Stingl and co-authors

Loraine.jl is a Julia package developed for H2020 ITN POEMA (http://poema-network.eu) 
and is distributed under the GNU General Public License 3.0. 
=#

module Loraine

export loraine
using SparseArrays
using LinearAlgebra
using Printf
using TimerOutputs
using FameSVD
# using MKLSparse
# using MKL

#modules
include("Solvers.jl")
using .Solvers

include("kron_etc.jl")
include("makeBBBB.jl")
include("initial_point.jl")
include("predictor_corrector.jl")
include("prepare_W.jl")
include("MOI_wrapper.jl")
include("multithreading.jl")

function loraine(d, options::Dict)

    verb   = Int64(get(options, "verb", 1))
    timing = Int64(get(options, "timing", 1))
    kit    = Int64(get(options, "kit", 1))
    drank    = Int64(get(options, "datarank", 1))
    κ = Int64(get(options,"datasparsity",1))
    if verb > 0
        t1 = time()
        # @printf("\n *** Loraine.jl v0.1 ***\n")
        # @printf(" *** Initialisation STARTS\n")
    end

    ```PREPARE MODEL```
    model = prepare_model_data(d,drank,κ)

    ```LOAD MODEL```
    solver, halpha = load(model,options)

    tottime = time() - t1
    # if verb > 0
    #     @printf(" *** Preprocessing finished in %8.2f seconds\n", tottime)
    # end

    solver.to = TimerOutput()
    t1 = time()

    # if verb > 0
    #     @printf(" *** IP STARTS\n")
    #     if verb < 2
    #         if kit == 0
    #             @printf(" it        obj         error     CPU/it\n")
    #         else
    #             @printf(" it        obj         error     cg_iter   CPU/it\n")
    #         end
    #     else
    #         if kit == 0
    #             @printf(" it        obj         error      err1      err2      err3      err4      err5      err6     CPU/it\n")
    #         else
    #             @printf(" it        obj         error      err1      err2      err3      err4      err5      err6     cg_pre cg_cor  CPU/it\n")
    #         end
    #     end
    # end

    ```SOLVE```
    @timeit solver.to "solver" begin
    solve(solver, halpha)
    end

    tottime = time() - t1

    if verb > 0
        # if kit == 1
        #     @printf(" *** Total CG iterations: %8.0d \n", solver.cg_iter_tot)
        # end
        # @printf(" *** Optimal solution found in %8.2f seconds\n", tottime)
    end
    
    if timing > 0
        show(solver.to)
    end
    @printf("\n")

end

end #module

# Benchmark Loraine on the SDPLIB test set and write a CSV of results.
#
# Usage (run once per branch, from the Loraine repo root):
#
#     julia --project=. examples/benchmark_sdplib.jl results_main.csv main
#     julia --project=. examples/benchmark_sdplib.jl results_nlpmodel.csv nlpmodel
#
# Args:  [1] output CSV path   (default "sdplib_results.csv")
#        [2] label for this run (default "loraine")  -> stored in the CSV
#
# Knobs (environment variables):
#   SDPLIB_MAXN     max matrix size  n to include (default 1000)
#   SDPLIB_MAXM     max #constraints m to include (default 3000)
#   SDPLIB_KIT      Loraine `kit` (0 = direct, 1 = CG; default 0)
#   SDPLIB_TIMEOUT  per-problem wall-clock limit in seconds (default 60)
#   SDPLIB_ONLY     comma-separated list of problem names to restrict to
#
# Each solve runs on a worker process so that a problem exceeding the timeout
# (or one that segfaults, e.g. the `kit=1` path) is force-killed without taking
# the whole benchmark down; the worker is then respawned for the next problem.
#
# Only options common to both `main` and `nlpmodel` are used, so the same
# script produces comparable CSVs on either branch. The CSV is written with a
# plain `print` (no CSV.jl dependency).
#
# The active project must have `Chairmarks` (used on the worker for a robust
# minimum solve time) in addition to `JuMP` and `Loraine`.

using Distributed
import Printf

const DATA = joinpath(@__DIR__, "SDPLIB", "data")
const README = joinpath(@__DIR__, "SDPLIB", "README.md")

# Parse the README table `| name | m | n | optimal | notes |` into
# name => (m, n, optimal). The only non-numeric optima are the four `inf*`
# (in)feasibility problems; anything else unexpected is a hard error.
function read_reference()
    isfile(README) || error("SDPLIB README not found at $README")
    ref = Dict{String,NamedTuple{(:m, :n, :opt),Tuple{Int,Int,Float64}}}()
    for line in eachline(README)
        startswith(line, "|") || continue # non-table line
        cells = strip.(split(line, "|")) # `| a | b |` -> ["", "a", "b", ""]
        name = cells[2]
        # Skip the header and the `| --- |` separator, parse everything else.
        (name == "Problem" || startswith(name, "-")) && continue
        length(cells) == 7 || error("Unexpected SDPLIB README row: $line")
        # README has a typo "eqaulG11" for the file "equalG11".
        name = name == "eqaulG11" ? "equalG11" : name
        opt = if cells[5] in ("dual infeasible", "primal infeasible")
            NaN
        else
            parse(Float64, cells[5])
        end
        ref[name] =
            (m = parse(Int, cells[3]), n = parse(Int, cells[4]), opt = opt)
    end
    return ref
end

# Spawn a worker that shares our project and knows how to solve one problem.
# Return both the Distributed id and the OS pid (so we can SIGKILL a stuck one).
function start_worker()
    pid = addprocs(1; exeflags = `--project=$(Base.active_project())`)[1]
    ospid = remotecall_fetch(getpid, pid)
    # Load in a separate eval from the function definition below: `@b` must be
    # macro-expanded *after* `using Chairmarks` has taken effect.
    remotecall_wait(Core.eval, pid, Main, quote
        using JuMP
        import Loraine
        using Chairmarks
    end)
    remotecall_wait(Core.eval, pid, Main, quote
        function solve_problem(path, kit)
            model = read_from_file(path)
            set_optimizer(model, Loraine.Optimizer{Float64})
            set_attribute(model, "kit", kit)
            set_attribute(model, "eDIMACS", 1e-6)
            set_attribute(model, "verb", 0)
            set_attribute(model, "maxit", 100)
            set_attribute(model, "datasparsity", 8)
            optimize!(model) # warm up: absorb this problem's compilation
            t = @elapsed optimize!(model)
            # Millisecond solves are noise-dominated (GC/scheduler jitter), so
            # take a robust minimum over repeated warm re-solves. Multi-second
            # solves are measured once: they aren't noisy, and re-running them
            # would risk blowing past the per-problem timeout.
            if t < 0.5
                t = (@b optimize!(model) seconds = 1).time
            end
            return (
                t,
                solve_time(model), # solver's own elapsed time (no harness)
                barrier_iterations(model),
                objective_value(model),
                string(termination_status(model)),
            )
        end
    end)
    return pid, ospid
end

launch(pid, path, kit) =
    remotecall((p, k) -> Main.solve_problem(p, k), pid, path, kit)

# Solve with a wall-clock cap. `isready` on a *remote* Future blocks while the
# worker is busy (it has to query the worker), so we instead let an async task
# `fetch` into a *local* Channel and poll that with `timedwait`.
# Returns (:ok, (t, obj, status)) | (:error, exception) | (:timeout, nothing).
function solve_capped(pid, path, kit, timeout)
    ch = Channel{Any}(1)
    @async put!(ch, try
        fetch(launch(pid, path, kit))
    catch err
        err
    end)
    if timedwait(() -> isready(ch), timeout; pollint = 0.2) === :ok
        r = take!(ch)
        return r isa Exception ? (:error, r) : (:ok, r)
    end
    return (:timeout, nothing)
end

function bench(;
    out = get(ARGS, 1, "sdplib_results.csv"),
    label = get(ARGS, 2, "loraine"),
    maxn = parse(Int, get(ENV, "SDPLIB_MAXN", "1000")),
    maxm = parse(Int, get(ENV, "SDPLIB_MAXM", "3000")),
    kit = parse(Int, get(ENV, "SDPLIB_KIT", "0")),
    timeout = parse(Float64, get(ENV, "SDPLIB_TIMEOUT", "60")),
)
    only = haskey(ENV, "SDPLIB_ONLY") ? Set(split(ENV["SDPLIB_ONLY"], ",")) :
           nothing
    ref = read_reference()

    problems = String[]
    for f in sort(readdir(DATA))
        endswith(f, ".dat-s") || continue
        name = f[1:(end-length(".dat-s"))]
        isnothing(only) || name in only || continue
        r = ref[name] # every data file is in the README
        (r.n <= maxn && r.m <= maxm) || continue
        push!(problems, name)
    end
    # smallest first, so quick problems report early
    sort!(problems, by = p -> ref[p].n)
    isempty(problems) && return

    pid, ospid = start_worker()
    # Warm up compilation on the smallest problem so timings exclude it.
    warmup = joinpath(DATA, problems[1] * ".dat-s")
    fetch(launch(pid, warmup, kit))

    open(out, "w") do io
        println(
            io,
            "label,problem,m,n,status,time_s,solve_time_s,iterations,objective,optimal,rel_gap",
        )
        ntot = length(problems)
        for (idx, name) in enumerate(problems)
            r = ref[name]
            status, t, st, iters, obj = "ok", NaN, NaN, -1, NaN
            outcome, payload =
                solve_capped(pid, joinpath(DATA, name * ".dat-s"), kit, timeout)
            if outcome === :ok
                t, st, iters, obj, status = payload
            elseif outcome === :error
                status = "ERROR: " * sprint(showerror, payload)[1:min(end, 60)]
            else
                # Stuck: SIGKILL the worker's OS process, then respawn a fresh
                # one (and re-warm it) for the remaining problems.
                run(`kill -9 $ospid`)
                rmprocs(pid; waitfor = 0)
                status, t = "TIMEOUT", timeout
                pid, ospid = start_worker()
                fetch(launch(pid, warmup, kit))
            end
            gap = isfinite(obj) && isfinite(r.opt) ?
                  abs(obj - r.opt) / max(1, abs(r.opt)) : NaN
            println(
                io,
                join(
                    [
                        label,
                        name,
                        r.m,
                        r.n,
                        "\"$status\"",
                        round(t, sigdigits = 5),
                        round(st, sigdigits = 5),
                        iters,
                        obj,
                        r.opt,
                        gap,
                    ],
                    ",",
                ),
            )
            Printf.@printf(
                "[%2d/%2d] %-12s n=%-5d m=%-5d  %8.3fs (solve %8.3fs, %3d it)  obj=%-14.6g %s\n",
                idx,
                ntot,
                name,
                r.n,
                r.m,
                t,
                st,
                iters,
                obj,
                status,
            )
            flush(io)
        end
    end
    rmprocs(pid)
    println("\nWrote ", out)
end

bench()

# module tvp

using SparseArrays
using LinearAlgebra
using Printf
using TimerOutputs
using JSON
# using MKL
# using Profile
# using ProfileView

using Loraine

const to = TimerOutput()

# READING the input file in POEMA-JSON format

tmp = JSON.parsefile("Loraine/examples/tru3.json")

didi = Dict()
didi["name"] = get(tmp, "name", 1)
didi["type"] = get(tmp, "type", 1)
nvar = get(tmp, "nvar", 1)
didi["nvar"] = convert(Int64,nvar)
didi["c"] = Vector{Float64}(get(tmp, "objective", 1)[:])

tmpcon = get(tmp, "constraints",1)
nlmi = get(tmpcon, "nlmi", 1)
didi["nlmi"] = convert(Int64,nlmi)
msizes = get(tmpcon, "msizes", 1)
if nlmi == 1
    didi["msizes"] = msizes
else
    didi["msizes"] = Vector{Int64}(msizes)
end

tmpA = get(tmpcon, "lmi_symat", 1)

lA = length(tmpA)
BB = zeros(nlmi, nvar + 1, maximum(tmpA)[4], maximum(tmpA)[5])
for i in eachindex(tmpA)
    BB[tmpA[i][3],tmpA[i][2]+1,tmpA[i][4],tmpA[i][5]] = tmpA[i][1]
end

A = SparseMatrixCSC{Float64,Int}[]
# A = Matrix{Any}
if nlmi == 1  
    Btmp = SparseMatrixCSC{Float64,Int}[]
    Ctmp = sparse(BB[1,1,:,:])
    Ctmp = Ctmp + Ctmp' - spdiagm(diag(Ctmp))
    push!(Btmp,Ctmp)
    for j = 1:nvar+1
        push!(A,sparse(BB[1,j,:,:]))
    end
else
    for ilmi = 1:nlmi
        Btmp = SparseMatrixCSC{Float64,Int}[]
        for j = 1:nvar+1
            push!(Btmp,sparse(BB[ilmi,j,:,:]))
        end
        push!(A,Btmp)
    end
end
didi["A"] = A

nlsi = get(tmpcon, "nlsi", 1)
didi["nlsi"] = convert(Int64,nlsi)
tmpC = get(tmpcon, "lsi_mat", 1)
iii = zeros(nlsi)
jjj = zeros(nlsi)
vvv = zeros(nlsi)
for i = 1:nlsi
    iii[i] = tmpC[i][2]
    jjj[i] = tmpC[i][3]
    vvv[i] = tmpC[i][1]
end
didi["C"] = sparse(iii,jjj,vvv,nlsi,nvar)
dtmp = sparse(get(tmpcon, "lsi_vec", 1)[:])
didi["d"] = convert(SparseVector{Float64},dtmp)
didi["lsi_op"] = convert(Vector{Int64},get(tmpcon, "lsi_op", 1)[:])

@show didi

# OPTIONS FOR myIP
options = Dict{String,Float64}()
options["kit"]          = 1         # kit = 0 for direct solver; kit = 1 for CG
options["tol_cg"]       = 1e-1      # tolerance for CG solver [1e-2]
options["tol_cg_up"]    = 0.5       # tolerance update [0.5]
options["tol_cg_min"]   = 1e-6      # minimal tolerance for CG solver [1e-6]
options["eDIMACS"]      = 3e-5      # epsilon for DIMACS error stopping criterion [1e-5]

options["prec"]  = 1    # 0...no; 1...H_tilde with SMW; 2...H_hat; 3...H_tilde inverse; 4...hybrid
options["erank"] = 1    # estimated rank()

options["aamat"] = 2    # 0 ... A^TA; 1 ... diag(A^TA); 2 ... identity

# Use fig_ev=1 only for small problems!!! switches to preconditioner = 3 !!!
options["fig_ev"]   = 0  # 0...no figure; 1.1.figure with eigenvalues of H; H_til; etc in every IP iteration

options["verb"]     = 1   # 2..full output; 1..short output; 0..no output
options["maxit"]    = 200

# CALLING Loraine

loraine(didi,options)

# end

using JuMP
import LinearAlgebra
# import Plots
import Random
# import SCS
import Loraine
import Test

function svd_cholesky(X::AbstractMatrix)
    F = LinearAlgebra.svd(X)
    # We now have `X ≈ `F.U * D² * F.U'` where:
    D = LinearAlgebra.Diagonal(sqrt.(F.S))
    # So `X ≈ U' * U` where `U` is:
    return (F.U * D)'
end

function solve_max_cut_sdp(weights)
    N = size(weights, 1)
    # Calculate the (weighted) Laplacian of the graph: L = D - W.
    L = LinearAlgebra.diagm(0 => weights * ones(N)) - weights
    model = Model(Loraine.Optimizer)
    # set_silent(model)
    MOI.set(model, MOI.RawOptimizerAttribute("kit"), 0)
    @variable(model, X[1:N, 1:N], PSD)
    for i in 1:N
        set_start_value(X[i, i], 1.0)
    end
    @objective(model, Max, 0.25 * LinearAlgebra.dot(L, X))
    @constraint(model, LinearAlgebra.diag(X) .== 1)
    optimize!(model)
    V = svd_cholesky(value(X))
    Random.seed!(N)
    r = rand(N)
    r /= LinearAlgebra.norm(r)
    cut = [LinearAlgebra.dot(r, V[:, i]) > 0 for i in 1:N]
    S = findall(cut)
    T = findall(.!cut)
    println("Solution:")
    println(" (S, T) = ({", join(S, ", "), "}, {", join(T, ", "), "})")
    return S, T
end

S, T = solve_max_cut_sdp([0 1 5 0; 1 0 0 9; 5 0 0 2; 0 9 2 0])

using Test
@test S == [1, 4]
@test T == [2, 3]

# Computes `⟨A * W, W * B⟩` for symmetric sparse matrices `A` and `B`
function _dot(A::SparseMatrixCSC, B::SparseMatrixCSC, W::AbstractMatrix)
    @assert LinearAlgebra.checksquare(W) == LinearAlgebra.checksquare(A) == LinearAlgebra.checksquare(B)
    # After these asserts, we know that `A`, `B` and `W` are square and
    # have the same sizes so we can safely use `@inbounds`
    result = zero(eltype(A))
    @inbounds for i in axes(A, 2)
        nzA = nzrange(A, i)
        if !isempty(nzA)
            for j in axes(B, 2)
                nzB = nzrange(B, j)
                if !isempty(nzB)
                    AW = zero(result)
                    for k in nzA
                        AW += nonzeros(A)[k] * W[rowvals(A)[k], j]
                    end
                    WB = zero(result)
                    for k in nzB
                        WB += W[i, rowvals(B)[k]] * nonzeros(B)[k]
                    end
                    result += AW * WB
                end
            end
        end
    end
    return result
end

function buffer_for_schur_complement(model::MyModel, κ)
    n = num_constraints(model)
    σ = zeros(Int64, n, num_matrices(model))
    last_dense = zeros(Int64, num_matrices(model))

    for mat_idx in matrix_indices(model)
        i = mat_idx.value
        nzA = [nnz(model.A[i, j]) for j in 1:n]
        σ[:,i] = sortperm(nzA, rev = true)
        sorted = nzA[σ[:,i]]

        last_dense[i] = something(findlast(Base.Fix1(isless, κ), sorted), 0)
    end

    return σ, last_dense
end

function makeBBBB_rank1(n,nlmi,B,G)
    BBBB = zeros(Float64, n, n)
    tmp = zeros(Float64, n, n)
    for ilmi = 1:nlmi
        BB = transpose(B[ilmi] * G[ilmi])
        mul!(tmp, BB', BB)
        @. BBBB += tmp * tmp
    end
    return BBBB
end

#########################

function schur_complement(buffer, model::MyModel, W, ::Type{MatrixIndex})
    n = num_constraints(model)
    BBBB = zeros(eltype(eltype(W)), n, n)
    for mat_idx in matrix_indices(model)
        BBBB .+= schur_complement(buffer, model, mat_idx, W[mat_idx.value])
    end
    return BBBB
end

#####
function schur_complement(buffer, model, mat_idx, W::AbstractMatrix{T}) where {T}
    σ, last_dense = buffer
    ilmi = mat_idx.value
    n = num_constraints(model)
    BBBB = zeros(T, n, n)
    dim = side_dimension(model, mat_idx)
    @assert dim == size(W, 1) == size(W, 2)
    tmp1 = Matrix{T}(undef, size(W, 2), dim)
    tmp  = Matrix{T}(undef, size(W, 2), dim)

    for ii = 1:n
        i = σ[ii,ilmi]
        Ai = model.A[ilmi, i]
        if nnz(Ai) > 0
            if ii <= last_dense[ilmi]
                mul!(tmp1, W, Ai)
                mul!(tmp, tmp1, W)
                tmp2 = jprod(model, mat_idx, tmp)
                indi = @view σ[ii:end,ilmi]
                BBBB[indi,i] .= -tmp2[indi]
                BBBB[i,indi] .= -tmp2[indi]
            else
                if !iszero(nnz(Ai))
                    if nnz(Ai) > 1
                        @inbounds for jj = ii:n
                            j = σ[jj,ilmi]
                            Aj = model.A[ilmi, j]
                            if !iszero(nnz(Aj))
                                ttt = _dot(Ai, Aj, W)
                                if i >= j
                                    BBBB[i,j] = ttt
                                else
                                    BBBB[j,i] = ttt
                                end
                            end  
                        end   
                    else
                        # A is symmetric
                        iiiiAi = jjjiAi = only(rowvals(Ai))
                        vvvi = only(nonzeros(Ai))
                        @inbounds for jj = ii:n
                            j = σ[jj,ilmi]
                            Ajjj = model.A[ilmi, j]
                            # As we sort the matrices in decreasing `nnz` order,
                            # the rest of matrices is either zero or have only
                            # one entry
                            if !iszero(nnz(Ajjj))
                                iiijAj = jjjjAj = only(rowvals(Ajjj))
                                vvvj = only(nonzeros(Ajjj))
                                ttt = vvvi * W[iiiiAi,iiijAj] * W[jjjiAi,jjjjAj] * vvvj
                                if i >= j
                                    BBBB[i,j] = ttt
                                else
                                    BBBB[j,i] = ttt
                                end
                            end
                        end 
                    end   
                end
            end
        end
    end
    return BBBB
end

# [HKS24, (5b)]
# Returns the matrix equal to the sum, for each equation, of
# ⟨A_i, WA_jW⟩
function schur_complement(buffer, model::MyModel, w, W::AbstractVector)
    H = MA.Zero()
    if num_matrices(model) > 0
        H = MA.add!!(H, schur_complement(buffer, model, W, MatrixIndex))
    end
    if num_scalars(model) > 0
        H = MA.add!!(H, schur_complement(model, w, ScalarIndex))
    end
    if H isa MA.Zero
        n = num_constraints(model)
        H = zeros(eltype(w), n, n)
    end
    return Hermitian(H, :L)
end

function schur_complement(model::MyModel, w, ::Type{ScalarIndex})
    return model.C_lin * spdiagm(w) * model.C_lin'
end

# [HKS24, (5b)]
# Returns the matrix equal to the sum, for each equation, of
# ⟨A_i, WA(y)W⟩
function eval_schur_complement!(buffer, result, model::MyModel, w, W, y)
    result .= 0.0
    for mat_idx in matrix_indices(model)
        i = mat_idx.value
        result .-= jprod(model, mat_idx, W[i] * jtprod!(buffer[i], model, mat_idx, y) * W[i])
    end
    result .+= model.C_lin * (w .* (model.C_lin' * y))
    return result
end

using Test

function run_examples(dir)
    for file in readdir(dir)
        if endswith(file, ".jl") && !(file in ["benchmark_sdplib.jl", "merge_results.jl"])
            @testset "$file" begin
                include(joinpath(dir, file))
            end
        end
    end
end
run_examples(joinpath(dirname(@__DIR__), "examples"))

include("MOI_wrapper.jl")

using JuMP
import MathOptInterface as MOI
import Loraine
# import SCS
using MultiFloats

# model = Model(Loraine.Optimizer)
model = Model(Loraine.Optimizer{Float64x2})
# model = JuMP.GenericModel{Float64x2}(Loraine.Optimizer{Float64x2})

# @variable(model, x >= 0)
# @variable(model, 0 <= y <= 3)
# @objective(model, Min, 12x + 20y)
# @constraint(model, c1, 6x + 8y >= 100)
# @constraint(model, c2, 7x + 12y >= 120)
@variable(model, x)
@objective(model, Max, 2*x)
# @constraint(model, csdp, [x 0; 0  x] - [1 0 ; 0 1] >= 0, PSDCone())
@constraint(model, c1, x >= 1)
@constraint(model, c2, x <= 2)

print(model)

optimize!(model)

solution_summary(model)

using Test
@test termination_status(model) == MOI.OPTIMAL
@test primal_status(model) == MOI.FEASIBLE_POINT
@test dual_status(model) == MOI.FEASIBLE_POINT
@test objective_value(model) ≈ 4 rtol = 1e-6

@test value(x) ≈ 2 rtol = 1e-6

@test shadow_price(c1) ≈ 0 atol = 1e-6

@test shadow_price(c2) ≈ 2 rtol = 1e-6

using LinearAlgebra
using SparseArrays
using Printf

function admm_sdp(sdpdata, maxiter=10000)
    # ADMM_SDP - Solves general linear SDP problems by the ADMM method as 
    # described in Z. Wen, D. Goldfarb, and W. Yin. "Alternating direction 
    # augmented Lagrangian methods for semidefinite programming." Mathematical
    # Programming Computation 2.3-4 (2010): 203-230.
    #
    # Input file: Julia dictionary in POEMA sparse format
    #
    # Elements of the dictionary "sdpdata"
    #   name ... filename of the input file
    #   type ... type of the problem (not used)
    #   nvar ... number of primal variables
    #   nlmi ... number of linear matrix inequalities (or diagonal blocks of the
    #            matrix constraint)
    #   c ...... dim (Nx,1), coefficients of the linear objective function
    #   msizes . vector of sizes of matrix constraints (diagonal blocks)
    #   A ...... dictionary of A[k,l] for k=1,...,Na matrix constraint
    #            for l=1 ~ absolute term, l=2..Nx+1 coeficient matrices
    #            (some of them might be empty)
    #
    # Copyright (c) 2019 Michal Kocvara, m.kocvara@bham.ac.uk
    # Last Modified: 9 Dec 2022
    # Translated to Julia: April 18, 2025

    
    # Setting parameters
    eps = 1e-6  # final precision required
    mu = 10.01  # Augmented Lagrangian penalty parameter
    rho = (1 + sqrt(5))/2 - 0.5  # step-length for the multiplier X
    
    # Parameters for update of mu
    gamma = 0.5
    mu_min = 1e-4
    mu_max = 1e4
    eta1 = 10000
    eta2 = 100
    h4 = 100

    # Read SDP input data
    n = Int64(sdpdata["nvar"])
    ncon = Int64(sdpdata["nlmi"])
    b = vec(sdpdata["c"])
    nlin = Int64(sdpdata["nlin"])

    if haskey(sdpdata, "lsi_op")
        key_lsi = 1
    else
        key_lsi = 0
    end

    sumlin = 0
    C_lin = nothing
    d_lin = nothing
    
    if nlin > 0
        if key_lsi == 1
            sumlin = sum(sdpdata["lsi_op"])
            eqc = nlin - sumlin
            if sumlin < nlin
                d_lin = zeros(nlin)
                C_lin = zeros(size(sdpdata["C"], 1), nlin)
                ieq = 1
                indieq = Int[]
                
                for i in 1:nlin
                    if sdpdata["lsi_op"][i] == 0
                        C_lin[:, i] = -sdpdata["C"][:, i]
                        d_lin[i] = sdpdata["d"][i]
                        push!(indieq, i)
                        ieq += 1
                    else
                        C_lin[:, i] = -sdpdata["C"][:, i]
                        d_lin[i] = sdpdata["d"][i]
                    end
                end
                
                # Extend C_lin and d_lin
                C_lin = hcat(C_lin, sdpdata["C"][:, indieq])
                d_lin = vcat(d_lin, -sdpdata["d"][indieq])
            else
                d_lin = -sdpdata["d"]
                C_lin = -sdpdata["C"]
            end
        else
            d_lin = -sdpdata["d"]
            C_lin = -sdpdata["C"]
        end
    end

    if key_lsi == 1 && nlin > 0
        nlin = nlin + eqc
    end

    C = Dict()
    m = zeros(Int, ncon)
    for icon in 1:ncon
        C[icon] = -sdpdata["A"][icon, 1]
        m[icon] = size(C[icon], 1)
    end

    AAT = spzeros(n, n)
    aaa = Dict()
    A = Dict()
    
    for icon in 1:ncon
        aaa[icon] = []
        for i in 1:n
            A[(icon, i)] = sdpdata["A"][icon, i+1]
            aaa[icon] = [aaa[icon]; vec(A[(icon, i)])]
        end
        AAT += aaa[icon]' * aaa[icon]
    end
    
    if nlin > 0
        C_lin = sparse(C_lin)
        AAT += sparse(C_lin * C_lin')
    end
    
    # In Julia, we can use cholesky directly, which returns both the factorization and flag
    chol_result = cholesky(AAT, check=false)
    flag = issuccess(chol_result)
    if flag
        Rchol = chol_result.U
        Pchol = chol_result.P
    else
        # If Cholesky fails, use a more robust alternative
        # For example, using LU factorization or adding a small diagonal perturbation
        AAT += 1e-10 * I  # Add small regularization
        chol_result = cholesky(AAT)
        Rchol = chol_result.U
        Pchol = chol_result.P
    end

    println("================================= A D M M  for  S D P ===============================")
    println("Number of LMI Constraints: $(ncon)")
    println("Number of Variables: $(n)")
    println("Maximal Constraint Size: $(maximum(m))")
    println("Problem Name: \"$(sdpdata["name"])\"")

    # Initializing variables
    y = ones(n)
    S = Dict()
    X = Dict()
    
    for icon in 1:ncon
        S[icon] = sparse(I, m[icon], m[icon])
        X[icon] = sparse(I, m[icon], m[icon])
    end
    
    S_lin = nothing
    X_lin = nothing
    if nlin > 0
        S_lin = ones(nlin)
        X_lin = ones(nlin)
    end

    # Setting parameters
    println("-------------------------------------------------------------------------------------")
    println(" iter    p-infeas     d-infeas       d-gap           mu         error      objective")
    println("-------------------------------------------------------------------------------------")

    count = 1
    err = 1.0
    it_pinf = 0
    it_dinf = 0

    start_time = time()
    
    # ADMM main loop
    while err > eps
        # Update y
        Axb = spzeros(n)
        ASC = spzeros(n)
        
        for icon in 1:ncon
            Axb += aaa[icon]' * vec(X[icon])
            ASC += aaa[icon]' * (vec(S[icon]) - vec(C[icon]))
        end
        
        if nlin > 0
            Axb += C_lin * X_lin
            ASC += C_lin * (S_lin - d_lin)
        end
        
        # Using the Cholesky factorization for solving the system
        rhs = mu .* (Axb - b) + ASC
        y = -permute(Rchol \ (Rchol' \ (Pchol' * rhs)), Pchol)
        
        # Update S
        Vp = Dict()
        V = Dict()
        
        for icon in 1:ncon
            Vp[icon] = C[icon] - reshape(aaa[icon] * y, m[icon], m[icon])
            V[icon] = Vp[icon] - mu .* X[icon]
            
            eigen_decomp = eigen(Matrix(V[icon]))
            peval = max.(0, eigen_decomp.values)
            S[icon] = eigen_decomp.vectors * Diagonal(peval) * eigen_decomp.vectors'
            S[icon] = sparse(0.5 .* (S[icon] + S[icon]'))
        end
        
        Vp_lin = nothing
        V_lin = nothing
        if nlin > 0
            Vp_lin = d_lin - C_lin' * y
            V_lin = Vp_lin - mu .* X_lin
            S_lin = max.(V_lin, 0)
        end
        
        # Update X
        for icon in 1:ncon
            Xp = (1/mu) .* (S[icon] - V[icon])
            X[icon] = (1-rho) .* X[icon] + rho .* Xp
        end
        
        if nlin > 0
            Xp_lin = (1/mu) .* (S_lin - V_lin)
            X_lin = (1-rho) .* X_lin + rho .* Xp_lin
        end
        
        # Calculate current error
        dinf = 0.0
        dinfs = 0.0
        dgap = 0.0
        dgaps = 0.0
        pinf = norm(Axb - b)
        pinfs = pinf / (1 + norm(b))
        
        for icon in 1:ncon
            VS = vec(Vp[icon]) - vec(S[icon])
            dinfi = sqrt(dot(VS, VS))
            dinfsi = dinfi / (1 + norm(C[icon], 1))
            dinf += dinfi
            dinfs += dinfsi
            
            dgapi = dot(vec(C[icon]), vec(X[icon]))
            dgapsi = abs(dgapi)
            dgap += dgapi
            dgaps += dgapsi
        end
        
        if nlin > 0
            dinfi = sqrt(dot(Vp_lin - S_lin, Vp_lin - S_lin))
            dinf += dinfi
            dinfs += dinfi / (1 + norm(d_lin, 1))
            
            dgapi = dot(d_lin, X_lin)
            dgapsi = abs(dgapi)
            dgap += dgapi
            dgaps += dgapsi
        end

        dgap = abs(dot(b, y) - dgap)
        dgaps = dgap / (1 + abs(dot(b, y)) + dgaps)
        
        err = max(pinfs, max(dinfs, dgaps))
        count += 1
        
        # Update penalty parameter mu
        if pinf + dinf > 2
            if pinf / dinf < eta1
                it_pinf += 1
                it_dinf = 0
                if it_pinf > h4
                    mu = max(gamma * mu, mu_min)
                    it_pinf = 0
                end
            elseif pinf / dinf > eta2
                it_dinf += 1
                it_pinf = 0  # Fixed typo from the original code: it_finf -> it_pinf
                if it_dinf > h4
                    mu = min(mu / gamma, mu_max)
                    it_dinf = 0
                end
            end
        end
        
        if count % 100 == 0
            @printf("%5d   %.8f   %.8f   %.8f   %.8f   %.6f   %.8f\n", 
                    count, pinfs, dinfs, dgaps, mu, err, dot(b, y))
        end
        
        if count > maxiter
            break
        end
    end
    
    elapsed_time = time() - start_time

    y = -y
    
    # Save results to JLD2 file (Julia's equivalent to MATLAB's save)
    # using JLD2
    # @save "admm_sol.jld2" y X S
    
    # Alternative: just return the results
    @printf("%5d   %.8f   %.8f   %.8f   %.8f   %.6f   %.8f\n", 
            count, pinfs, dinfs, dgaps, mu, err, dot(b, y))
    println("-------------------------------------------------------------------------------------")
    
    lambda_min = minimum(eigen(Matrix(X[1])).values)
    min_el = minimum(X[1])
    @printf("Minimal eigenvalue of X: %4.2e; Minimal element of X:  %4.2e\n", lambda_min, min_el)
    println("-------------------------------------------------------------------------------------")
    @printf("Total ADMM iterations: %3d; Final precision: %4.2e; CPU Time %2.2fsec\n", 
            count, err, elapsed_time)
    println("=====================================================================================")
    
    return y, X, S
end

using Test
import MathOptInterface as MOI
import Loraine
using JuMP

function tests()
    optimizer = Loraine.Optimizer()
    # MOI.set(optimizer, MOI.RawOptimizerAttribute("eDIMACS"), 1e-6) # comment this to enable output
    MOI.set(optimizer, MOI.Silent(), false) # comment this to enable output
    bridged = MOI.instantiate(Loraine.Optimizer, with_bridge_type = Float64)
    # Fix for `Unable to query the dual of a variable bound that was reformulated using `ZerosBridge`.
    MOI.Bridges.remove_bridge(bridged, MOI.Bridges.Variable.ZerosBridge{Float64})
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        bridged,
    )
    # MOI.set(model, MOI.RawOptimizerAttribute("eDIMACS"), 1e-5)
    MOI.set(model, MOI.RawOptimizerAttribute("kit"), 0)
    MOI.set(model, MOI.RawOptimizerAttribute("initpoint"), 1)
    MOI.set(model, MOI.Silent(), true) # comment this to enable output
    config = MOI.Test.Config(
        atol = 1e-2,
        exclude = Any[
            MOI.ConstraintBasisStatus,
            MOI.VariableBasisStatus,
            MOI.ConstraintName,
            MOI.VariableName,
            MOI.ObjectiveBound,
            MOI.SolverVersion,
        ],
    )
    MOI.Test.runtests(
        model,
        config,
        exclude = [
            # No constraints
            r"test_solve_TerminationStatus_DUAL_INFEASIBLE$",

            # Unable to bridge RotatedSecondOrderCone to PSD because the dimension is too small: got 2, expected >= 3
            r"test_conic_SecondOrderCone_INFEASIBLE$",
            r"test_constraint_PrimalStart_DualStart_SecondOrderCone$",

            # MathOptInterface.ITERATION_LIMIT == MathOptInterface.DUAL_INFEASIBLE
            r"test_linear_DUAL_INFEASIBLE_2$",
            r"test_conic_SecondOrderCone_no_initial_bound$",
            r"test_conic_SecondOrderCone_negative_post_bound_2$",
            r"test_conic_SecondOrderCone_negative_post_bound_3$",

            # PosDefException: matrix is not positive definite; Cholesky factorization failed.
            r"test_attribute_SolveTimeSec$",
            r"test_attribute_RawStatusString$",
            r"test_objective_ObjectiveFunction_blank$",
            r"test_linear_transform$",
            r"test_linear_DUAL_INFEASIBLE$",
        ],
    )
    return
end

@testset "MOI tests" begin
    tests()
end

@testset "BarrierIterations" begin
    # min 2 X₁₂ s.t. diag(X) = 1, X ⪰ 0  (optimal X₁₂ = -1)
    model = Model(Loraine.Optimizer)
    set_silent(model)
    @variable(model, X[1:2, 1:2] in PSDCone())
    @constraint(model, X[1, 1] == 1)
    @constraint(model, X[2, 2] == 1)
    @objective(model, Min, 2 * X[1, 2])
    optimize!(model)
    @test termination_status(model) == MOI.OPTIMAL
    iters = MOI.get(model, MOI.BarrierIterations())
    @test iters isa Integer
    @test 0 < iters <= 100 # solver default `maxit`
end

using ConjugateGradients
using GenericLinearAlgebra

function predictor(solver::MySolver{T},halpha::Halpha) where {T}

    solver.predict = true
    copyto!(solver.Rp, solver.model.b)

    if solver.model.nlmi > 0
        for i = 1:solver.model.nlmi
            mul!(solver.Rp, solver.model.AA[i], vec(solver.X[i]), -1.0, 1.0)
        end
        Threads.@threads for i = 1:solver.model.nlmi
            mul!(solver.work_m2[i], solver.model.AA[i]', solver.y)
            mat!(solver.work_mm[i], solver.work_m2[i])
            solver.Rd[i] .= solver.model.C[i] .- solver.S[i] .- solver.work_mm[i]
        end
    end

    if solver.model.nlin > 0
        mul!(solver.Rp, solver.model.C_lin, solver.X_lin, -1.0, 1.0)
        solver.Rd_lin = solver.model.d_lin - solver.S_lin - solver.model.C_lin' * solver.y
    end

    if solver.kit == 0   # if direct solver; compute the Hessian matrix
        if solver.model.nlmi > 0
            if solver.datarank == -1
                BBBB = makeBBBB_rank1(solver.model.n, solver.model.nlmi, solver.model.B, solver.G, solver.to)
            else
                BBBB = makeBBBBs(solver.model.n, solver.model.nlmi, solver.model.A, solver.model.AA, solver.W, solver.to, solver.model.qA, solver.model.sigmaA)
            end
        else
            BBBB = zeros(T, solver.model.n, solver.model.n)
        end
        if solver.model.nlin > 0
            BBBB .+= solver.model.C_lin * Diagonal(solver.X_lin .* solver.Si_lin) * solver.model.C_lin'
        end
        BBBB = Hermitian(BBBB, :L)
    end
    # end

    if solver.model.nlmi > 0
        h = makeRHS(solver.model.nlmi,solver.model.AA,solver.W,solver.S,solver.Rp,solver.Rd)
    else
        h = copy(solver.Rp)
    end
    if solver.model.nlin > 0
        h .+= solver.model.C_lin * (Diagonal(solver.X_lin .* solver.Si_lin) * solver.Rd_lin + solver.X_lin)
    end

    # solving the linear system()
    if solver.kit == 0   # direct solver
    #     @timeit solver.to "backslash" begin
        if ishermitian(BBBB)
            try
                cholBBBB1, _ = cholesky(BBBB)
                solver.cholBBBB = cholBBBB1
            catch
                if solver.verb > 0
                    println("Matrix H not positive definite, trying to regularize")
                end
                icount = 0
                solver.regcount += 1
                if solver.regcount > 5
                    if solver.verb > 0
                        println("WARNING: too many regularizations of H, giving up")
                    end
                    solver.cholBBBB = I(size(BBBB, 1))
                    solver.status = 3
                    return
                end
                while isposdef(BBBB) == false
                    BBBB = BBBB + 1e-4 .* I(size(BBBB, 1))
                    icount = icount + 1
                    if icount > 1000
                        if solver.verb > 0
                            println("WARNING: H cannot be made positive definite, giving up")
                        end
                        solver.cholBBBB = I(size(BBBB, 1))
                        solver.status = 3
                        return
                    end
                end
                solver.cholBBBB = cholesky(BBBB)
            else
                solver.cholBBBB = copy(solver.cholBBBB)
            end
            solver.dely = solver.cholBBBB' \ (solver.cholBBBB \ h)
            # delyy = solver.dely
        else
            @warn("System matrix not Hermitian, stopping Loraine")
            solver.maxit = 1e10
            solver.status = 2
            solver.cholBBBB = 0
        end
    #     end
    else
        A = MyA(solver.W,solver.model.AA,solver.model.nlin,solver.model.C_lin,solver.X_lin,solver.S_lin_inv,solver.to)
        if solver.preconditioner == 0
            M = MyM_no(solver.to)
        elseif solver.preconditioner == 1
            Prec_for_CG_tilS_prep(solver,halpha)
            M = MyM(solver.model.AA, halpha.AAAATtau_fact, halpha.Umat, halpha.Z, halpha.cholS)
        elseif solver.preconditioner == 2 || solver.preconditioner == 4
            Prec_for_CG_beta(solver,halpha)
            M = MyM_beta(solver.model.AA, halpha.AAAATtau)
        end

        # @timeit solver.to "CG predictor" begin
        # ConjugateGradients.jl needs `tol` to be `Float64`,
        # maybe we can fix this in that package but in the mean time, we just
        # convert the tolerance to `Float64`
        solver.dely, exit_code, num_iters = cg(A, h[:]; tol = Float64(solver.tol_cg), maxIter = Int64(10000), precon = M)
        # end

        # print(num_iters, exit_code)
        solver.cg_iter_pre += num_iters
        solver.cg_iter_tot += num_iters
    end

    # @timeit solver.to "find step predictor" begin
    find_step(solver)
    # end

end

function sigma_update(solver::MySolver{T}) where {T}
    step_pred = min(
        minimum(solver.alpha; init = one(T)),
        solver.alpha_lin,
        minimum(solver.beta; init = one(T)),
        solver.beta_lin,
    )
    if (solver.mu > 1e-6)
        if (step_pred < 1 / sqrt(3))
                expon_used = 1.0
        else
                expon_used = max(solver.expon, T(3) * step_pred^2)
        end
    else
            expon_used = max(1, min(solver.expon, T(3) * step_pred^2))
    end
    trXnSn = btrace(solver.model.nlmi, solver.Xn, solver.Sn)
    if trXnSn < 0
        solver.sigma = T(0.8)
    else
        if solver.model.nlmi > 0
            tmp1 = trXnSn
        else
            tmp1 = 0
        end
        if solver.model.nlin > 0
                tmp2 = dot(solver.Xn_lin', solver.Sn_lin)
        else
                tmp2 = 0
        end
        tmp12 = (tmp1 + tmp2) / (sum(solver.model.msizes) + solver.model.nlin)
        tmp12 = convert(Float64, tmp12)
        mu = Float64(solver.mu)
        solver.sigma = min(1.0, ((tmp12) / mu) ^ Float64(expon_used))
    end

    return solver.sigma
end

function corrector(solver,halpha)
    solver.predict = false
    h = copy(solver.Rp)
    if solver.model.nlmi > 0
        for i = 1:solver.model.nlmi
            mul!(h, solver.model.AA[i], my_kron(solver.G[i], solver.G[i], (solver.G[i]' * solver.Rd[i] * solver.G[i] + Diagonal(@. solver.D[i] - (solver.sigma * solver.mu) / solver.D[i]) - solver.RNT[i])), true, true)
        end
    end
    if solver.model.nlin > 0
        tmp = (solver.delX_lin .* solver.delS_lin) .* (solver.Si_lin) - (solver.sigma * solver.mu) .* (solver.Si_lin)
        h .+= solver.model.C_lin * (Diagonal(solver.X_lin .* solver.Si_lin) * solver.Rd_lin + solver.X_lin + tmp)
    end

    # solving the linear system()
    if solver.kit == 0   # direct solver
    # @timeit to "corrector backsl" begin
        solver.dely = solver.cholBBBB' \ (solver.cholBBBB \ h)
    else
        A = MyA(solver.W,solver.model.AA,solver.model.nlin,solver.model.C_lin,solver.X_lin,solver.S_lin_inv,solver.to)
        if solver.preconditioner == 0
            M = MyM_no(solver.to)
        elseif solver.preconditioner == 1
            M = MyM(solver.model.AA, halpha.AAAATtau_fact, halpha.Umat, halpha.Z, halpha.cholS)
        else
            M = MyM_beta(solver.model.AA, halpha.AAAATtau)
        end

        @timeit solver.to "CG corrector" begin
            solver.dely, exit_code, num_iters = cg(A, h[:]; tol = Float64(solver.tol_cg), maxIter = Int64(10000), precon = M)
        end
        solver.cg_iter_cor += num_iters
        solver.cg_iter_tot += num_iters
    end
    # end

    # find delX, delS
    @timeit solver.to "find step corrector" begin
    find_step(solver)
    end
end

function find_step(solver::MySolver{T}) where {T}
    if solver.model.nlmi > 0
        @timeit solver.to "find_step" begin
        for i = 1:solver.model.nlmi
            mul!(solver.work_m2[i], solver.model.AA[i]', solver.dely)
            mat!(solver.work_mm[i], solver.work_m2[i])
            solver.delS[i] .= solver.Rd[i] .- solver.work_mm[i]
            Ξ = my_kron(solver.W[i], solver.W[i], solver.delS[i])
            if solver.predict
                solver.delX[i] .= mat(-vec(solver.X[i]) .- Ξ)
            else
                solver.delX[i] .= mat(((solver.sigma * solver.mu) .* solver.Si[i] .- solver.X[i])[:] .- Ξ .+ my_kron(solver.G[i], solver.G[i], solver.RNT[i]))
            end

            delSb = solver.G[i]' * solver.delS[i] * solver.G[i]
            delXb = solver.Gi[i] * solver.delX[i] * solver.Gi[i]'

            XXX = @. solver.DDsi[i]' * delXb * solver.DDsi[i]
            XXX .= (XXX .+ XXX') ./ 2
            mimiX = minimum(eigvals(Symmetric(XXX)))
            solver.alpha[i] = mimiX > -1e-6 ? T(0.99) : min(T(1), -solver.tau / mimiX)

            @. XXX = solver.DDsi[i]' * delSb * solver.DDsi[i]
            XXX .= (XXX .+ XXX') ./ 2
            mimiS = minimum(eigvals(Symmetric(XXX)))
            solver.beta[i] = mimiS > -1e-6 ? T(0.99) : min(T(1), -solver.tau / mimiS)
        end
        end
    end

    if solver.model.nlin > 0
        find_step_lin(solver)
    else
        solver.alpha_lin = 1
        solver.beta_lin = 1
    end

    if solver.predict
        if solver.model.nlmi > 0
            Threads.@threads for i = 1:solver.model.nlmi
                @. solver.Xn[i] = solver.X[i] + solver.alpha[i] * solver.delX[i]
                @. solver.Sn[i] = solver.S[i] + solver.beta[i] * solver.delS[i]
                deed = solver.D[i] .+ solver.D[i]'
                solver.RNT[i] .= -(solver.Gi[i] * solver.delX[i] * solver.delS[i] * solver.G[i] + solver.G[i]' * solver.delS[i] * solver.delX[i] * solver.Gi[i]') ./ deed
            end
        end
    else
        solver.yold = copy(solver.y)
        beta_step = min(minimum(solver.beta; init = one(T)), solver.beta_lin)
        LinearAlgebra.axpy!(beta_step, solver.dely, solver.y)
        if solver.model.nlmi > 0
            alpha_step = min(minimum(solver.alpha), solver.alpha_lin)
            Threads.@threads for i = 1:solver.model.nlmi
                @. solver.X[i] += alpha_step * solver.delX[i]
                solver.X[i] .= (solver.X[i] .+ solver.X[i]') ./ 2
                @. solver.S[i] += beta_step * solver.delS[i]
                solver.S[i] .= (solver.S[i] .+ solver.S[i]') ./ 2
            end
        end
    end

    return
end


function find_step_lin(solver)
    solver.delS_lin = solver.Rd_lin - solver.model.C_lin' * solver.dely
    if solver.predict
        solver.delX_lin = -solver.X_lin - (solver.X_lin) .* (solver.Si_lin) .* solver.delS_lin
    else
        solver.delX_lin = -solver.X_lin - (solver.X_lin) .* (solver.Si_lin) .* solver.delS_lin + (solver.sigma * solver.mu) .* (solver.Si_lin) + solver.RNT_lin
    end
    mimiX_lin = minimum(solver.delX_lin ./ solver.X_lin)
    if mimiX_lin > -1e-6
        solver.alpha_lin = 0.99
    else
        solver.alpha_lin = min(1, -solver.tau / mimiX_lin)
    end
    mimiS_lin = minimum(solver.delS_lin ./ solver.S_lin)
    if mimiS_lin > -1e-6
        solver.beta_lin = 0.99
    else
        solver.beta_lin = min(1, -solver.tau / mimiS_lin)
    end

    if solver.predict
        # solution update
        solver.Xn_lin = solver.X_lin + solver.alpha_lin .* solver.delX_lin
        solver.Sn_lin = solver.S_lin + solver.beta_lin .* solver.delS_lin

        solver.RNT_lin = -(solver.delX_lin .* solver.delS_lin) .* solver.Si_lin
    else
        solver.X_lin = solver.X_lin + min(minimum(solver.alpha; init = one(eltype(solver.alpha_lin))), solver.alpha_lin) .* solver.delX_lin
        solver.S_lin = solver.S_lin + min(minimum(solver.beta; init = one(eltype(solver.beta_lin))), solver.beta_lin) .* solver.delS_lin
        solver.S_lin_inv = 1 ./ solver.S_lin
    end

    return
end

export prepare_model_data, MyModel

using SparseArrays
using Printf
using TimerOutputs
using LinearAlgebra

"""
    MyModel

Model representing the problem:
```math
\\begin{aligned}
\\max {} & b^\\top y - b_\\text{const}
\\\\
& \\sum_{j=1}^n y_j A_{i,j} \\preceq C_i
\\qquad
\\forall i \\in \\{1,\\ldots,\\text{nlmi}\\}
\\\\
& C_\\text{lin} y \\le d_\\text{lin}
\\end{aligned}
```
The fields of the `struct` as related to the arrays of the above formulation as follows:

* The ``i``th PSD constraint is of size `msize[i] × msisze[i]`
* The matrix ``C_i`` is given by `C[i]` which should be equal to `-A[i,1]`.
* The matrix ``A_{i,j}`` is given by `-A[i,j+1]` as well as `myA[(i-1)*n + j]`.
* The vectorization `vec(A[i,j+1])` is also given by `-AA[i][:,j]`
* If `datarank == -1`, ``A_{i,j}`` is also equal to `-B[i][j,:] * B[i][j,:]'`.
* The matrix ``A_{i,j}`` has `nzA[j,i]` nonzero entries
* The index `j = sigmaA[k,i]` is the `k`th matrix ``A_{i,j}`` of the largest number of nonzeros.
* The first `qA[1,i] = qA[2,i]` matrices are considered as dense in the computation.
"""
mutable struct MyModel
    A::Matrix{SparseArrays.SparseMatrixCSC{Float64,Int}}
    AA::Vector{SparseArrays.SparseMatrixCSC{Float64,Int}}
    B::Vector{SparseArrays.SparseMatrixCSC{Float64,Int}}
    C::Vector{SparseArrays.SparseMatrixCSC{Float64,Int}}
    nzA::Matrix{Int64}
    sigmaA::Matrix{Int64}
    qA::Matrix{Int64}
    b::Vector{Float64}
    b_const::Float64
    d_lin::SparseArrays.SparseVector{Float64, Int64}
    C_lin::SparseArrays.SparseMatrixCSC{Float64, Int64}
    n::Int64
    msizes::Vector{Int64}
    nlin::Int64
    nlmi::Int64

    function MyModel(
        A::Matrix{SparseArrays.SparseMatrixCSC{Float64,Int}},
        AA::Vector{SparseArrays.SparseMatrixCSC{Float64,Int}},
        B::Vector{SparseArrays.SparseMatrixCSC{Float64,Int}},
        C::Vector{SparseArrays.SparseMatrixCSC{Float64,Int}},
        nzA::Matrix{Int64},
        sigmaA::Matrix{Int64},
        qA::Matrix{Int64},
        b::Vector{Float64},
        b_const::Float64,
        d_lin::SparseArrays.SparseVector{Float64, Int64},
        C_lin::SparseArrays.SparseMatrixCSC{Float64, Int64},
        n::Int64,
        msizes::Vector{Int64},
        nlin::Int64,
        nlmi::Int64
        ) 

        model = new()
        model.A = A
        model.AA = AA
        model.B = B
        model.C = C
        model.nzA = nzA
        model.sigmaA = sigmaA
        model.qA = qA
        model.b = b
        model.b_const = b_const
        model.d_lin = d_lin
        model.C_lin = C_lin
        model.n = n
        model.msizes = msizes
        model.nlin = nlin
        model.nlmi = nlmi
        return model
    end
end


function prepare_model_data(d,drank)

msizes = Vector{Int64}
n = Int64(get(d, "nvar", 1));
msizesa = get(d, "msizes", 1)
if length(msizesa) == 1
    msizes = [convert.(Int64,msizesa)]
else
    msizes = convert.(Int64,msizesa[:])
end
nlin = Int64(get(d, "nlin", 1))
nlmi = Int64(get(d, "nlmi", 1))
A = get(d, "A", 1);
b = -get(d, "c", 1);
b_const = -get(d, "b_const", 1);

if nlin > 0
    d_lin = -get(d, "d", 1)
    d_lin = d_lin[:]
    C_lin = -get(d, "C", 1)
else
    d_lin = sparse([0.; 0.])
    C_lin = sparse([0. 0.;0. 0.])
end

model = MyModel(A, _prepare_A(A,drank,κ)..., b, b_const, d_lin, C_lin, n, msizes, nlin, nlmi)

return model
end

function _prepare_A(A, datarank, κ)

    nlmi = size(A, 1)
    n = size(A, 2) - 1
    AA = SparseMatrixCSC{Float64,Int}[]
    B = SparseMatrixCSC{Float64,Int}[]
    C = SparseMatrixCSC{Float64,Int}[]
    nzA = zeros(Int64,n,nlmi)
    sigmaA = zeros(Int64,n,nlmi)
    qA = zeros(Int64,2,nlmi)

    for i = 1:nlmi
        
        push!(C, copy(-A[i, 1]))

        Ai = A[i,:]
        m = size(Ai,1)
        AAA = prep_AA!(Ai,n)
        push!(AA, copy(AAA'))

        if datarank == -1
            Btmp = prep_B(A,n,i)
            push!(B, Btmp)
        end

        prep_sparse!(A,n,m,i,nzA,sigmaA,qA,κ)

    end

    return AA, B, C, nzA, sigmaA, qA
end


function prep_sparse!(A,n,m,i,nzA,sigmaA,qA,κ)
    # Simplified data sparsity handling

    for j = 1:n
        nzA[j,i] = nnz(A[i,j+1])
    end
    sigmaA[:,i] = sortperm(@view(nzA[:,i]), rev = true)
    sisi = nzA[sigmaA[:,i],i]
    # @show sisi

    qA[1,i] = n
    kappa = κ
    for j = 1:n
        if sisi[j] <= kappa
            qA[1,i] = j-1
            break
        end
    end
    qA[2,i] = qA[1,i]

    # @show qA
end

function prep_B(A,n,i)
    m = size(A[i, 1],1)
    Btmp = spzeros(n,m)

    for k = 1:n
        ii = rowvals(A[i, k + 1])
        bidx = unique(ii)
        if !isempty(bidx)
            tmp = Matrix(A[i, k + 1][bidx, bidx])
            # utmp, vtmp = eigen(Hermitian(tmp))
            utmp, vtmp = eigen(@. (tmp + tmp') / 2)
            bbb = sign.(vtmp[:, end]) .* sqrt.(diag(tmp))
            tmp2 = bbb * bbb'
            if norm(tmp - tmp2) > 5.0e-6
                error("Obtained an error of `$(norm(tmp - tmp2)) > 5e-6` when converting matrix into rank `1`, use `datarank = 0` to disable the rank-1 conversion.")
            end
            Btmp[k, bidx] = bbb
        end
    end

    return Btmp
end

function prep_AA!(Ai,n)

    @inbounds Threads.@threads for j = 1:n
        if isempty(Ai[j+1])
            Ai[j+1][1, 1] = 0
        end
    end

    ntmp = size(Ai[1], 1) * size(Ai[1], 2)
    
    nnz = 0
    @inbounds for j = 1:n
        nnz += SparseArrays.nnz(Ai[j+1])
    end

    iii = zeros(Int64, nnz)
    jjj = zeros(Int64, nnz)
    vvv = zeros(Float64, nnz)
    lb = 1
    @inbounds for j = 1:n      
        ii,vv = findnz(-(Ai[j+1])[:])
        lf = lb+length(ii)-1
        iii[lb:lf] = ii
        jjj[lb:lf] .= j
        vvv[lb:lf] = float(vv)
        lb = lf+1
    end
    AAA = sparse(iii,jjj,vvv,ntmp,n)

    return AAA
end

# end #module


# function prep_sparse!(A,n,m,i,nzA,sigmaA,qA)
# This is the Kojima et al data sparsity handling
#     d1 = zeros(Float64,n)
#     d2 = zeros(Float64,n)
#     d3 = zeros(Float64,n)

#     kappa = 100
#     kappa = 500000/m
#     for j = 1:n
#         nzA[j,i] = nnz(A[i,j+1])
#     end
#     sigmaA[:,i] = sortperm(nzA[:,i], rev = true)
#     @show nzA[:,i]
#     # @show nzA[sigmaA[:,i],i]
#     sisi = sort(nzA[sigmaA[:,i],i], rev = true)
#     # @show sigmaA[:,i]
#     # @show sisi
#     cs = cumsum(sisi[end:-1:1])
#     cs = cs[n:-1:1]
#     # @show cs

#     for j = 1:n
#         d1[j] = kappa * m * nzA[sigmaA[j,i],i] + m^3 + kappa * cs[j]
#         d2[j] = kappa * m * nzA[sigmaA[j,i],i] + kappa * (n+1) * cs[j]
#         d3[j] = kappa * (2 * kappa * nzA[sigmaA[j,i],i] + 1) * cs[j]
#     end


#     qA[1,i] = 0
#     ktmp = 0
#     for j = 1:n
#         if d1[j] > min(d2[j],d3[j])
#             qA[1,i] = j-1
#             ktmp = 1
#             break
#         end
#     end
#     if ktmp == 0
#         qA[1,i] = n
#         qA[2,i] = n
#     else
#         qA[2,i] = 0
#         for j = max(1,qA[1,i]):n
#             if d2[j] >= d1[j] || d2[j] > d3[j]
#                 qA[2,i] = j-1
#                 break
#             end
#         end
#     end
#     qA[2,i] = max(qA[2,i],qA[1,i])

#     @show qA

# end

using SparseArrays
using LinearAlgebra
using MAT
using Printf
using TimerOutputs
# using MKL
# using Profile
# using ProfileView

using Loraine

const to = TimerOutput()

# READING the input file in Matlab format

file = matopen("/Users/michal/Dropbox/michal/POEMA/IP/ip-for-low-rank-sdp/d.mat")
d = read(file, "d")

c = get(d, "c", 1)
d["c"] = Vector{Float64}(c[:])
d["b_const"] = 0.0 

# OPTIONS FOR myIP
options = Dict{String,Float64}()
options["kit"]          = 0         # kit = 0 for direct solver; kit = 1 for CG
options["tol_cg"]       = 1e-2      # tolerance for CG solver [1e-2]
options["tol_cg_up"]    = 0.5       # tolerance update [0.5]
options["tol_cg_min"]   = 1e-6      # minimal tolerance for CG solver [1e-6]
options["eDIMACS"]      = 1e-6      # epsilon for DIMACS error stopping criterion [1e-5]

options["preconditioner"]  = 1    # 0...no; 1...H_tilde with SMW; 2...H_hat; 3...H_tilde inverse; 4...hybrid
options["erank"] = 1    # estimated rank()

options["aamat"] = 2    # 0 ... A^TA; 1 ... diag(A^TA); 2 ... identity

# Use fig_ev=1 only for small problems!!! switches to preconditioner = 3 !!!
options["fig_ev"]   = 0  # 0...no figure; 1.1.figure with eigenvalues of H; H_til; etc in every IP iteration

options["verb"]     = 1   # 2..full output; 1..short output; 0..no output
options["initpoint"]    = 0
options["maxit"]    = 10
options["datarank"] = 0

## CALLING Loraine

include("admm_sdp.jl")
admm_sdp(d,options)

# end

using JuMP
import LinearAlgebra
import Random
# import SCS
import Loraine
import Test

function example_minimum_distortion()
    model = Model(Loraine.Optimizer)
    # set_silent(model)
    MOI.set(model, MOI.RawOptimizerAttribute("kit"), 0)
    D = [
        0.0 1.0 1.0 1.0
        1.0 0.0 2.0 2.0
        1.0 2.0 0.0 2.0
        1.0 2.0 2.0 0.0
    ]
    @variable(model, c² >= 1.0)
    @variable(model, Q[1:4, 1:4], PSD)
    for i in 1:4, j in (i+1):4
        @constraint(model, D[i, j]^2 <= Q[i, i] + Q[j, j] - 2 * Q[i, j])
        @constraint(model, Q[i, i] + Q[j, j] - 2 * Q[i, j] <= c² * D[i, j]^2)
    end
    fix(Q[1, 1], 0)
    @objective(model, Min, c²)
    optimize!(model)
    Test.@test termination_status(model) == OPTIMAL
    Test.@test primal_status(model) == FEASIBLE_POINT
    Test.@test objective_value(model) ≈ 4 / 3 atol = 1e-4
    # Recover the minimal distorted embedding:
    return value(Q)
end

Q = example_minimum_distortion()
@test Q ≈ [
    0  0  0  0
    0  4 -2 -2
    0 -2  4 -2
    0 -2 -2  4
] / 3 rtol = 1e-6

function plot_distortion(Q)
    X = [zeros(3) sqrt(Q[2:end, 2:end])]
    return Plots.plot(
        X[1, :],
        X[2, :],
        X[3, :];
        seriestype = :mesh3d,
        connections = ([0, 0, 0, 1], [1, 2, 3, 2], [2, 3, 1, 3]),
        legend = false,
        fillalpha = 0.1,
        lw = 3,
        ratio = :equal,
        xlim = (-1.1, 1.1),
        ylim = (-1.1, 1.1),
        zlim = (-1.5, 1.0),
        zticks = -1:1,
        camera = (60, 30),
    )
end

# import Plots
# plot_distortion(Q)

module Solvers

export  MySolver, solve, load, MyA, Halpha

using SparseArrays
using LinearAlgebra
import Statistics: mean
using Printf
using TimerOutputs
using MultiFloats
# using MKLSparse
# using MKL

include("kron_etc.jl")
include("makeBBBB.jl")
include("model.jl")

mutable struct MySolver{T}
    # main options
    kit::Int64
    tol_cg::T
    tol_cg_up::T
    tol_cg_min::T
    eDIMACS::T
    preconditioner::Int64
    erank::Int64
    aamat::Int64
    fig_ev::Int64
    verb::Int64
    datarank::Int64
    initpoint::Int64
    timing::Int64
    maxit::Int64
    datasparsity::Int64

    to::Any

    # model and preprocessed model data
    model::MyModel

    predict::Bool

    # current iterate
    sigma::T
    tau::T
    mu::T
    expon::T
    iter::Int64
    DIMACS_error::T
    cholBBBB

    status::Int

    regcount::Int

    err1::T
    err2::T
    err3::T
    err4::T
    err5::T
    err6::T

    X
    S
    y
    yold
    delX
    delS
    dely
    Xn
    Sn

    X_lin
    S_lin
    Si_lin
    S_lin_inv
    delX_lin
    delS_lin
    Xn_lin
    Sn_lin

    D
    G
    Gi
    W
    Si
    DDsi

    norm_b::Float64
    norm_C::Vector{Float64}
    norm_d::Float64

    Rp
    Rd
    Rd_lin
    work_m2
    work_mm

    cg_iter_pre
    cg_iter_cor
    cg_iter_tot

    alpha
    beta
    alpha_lin
    beta_lin

    itertime
    tottime

    RNT
    RNT_lin

    function MySolver{T}(
        kit::Int64,
        tol_cg::Float64 ,
        tol_cg_up::Float64 ,
        tol_cg_min::Float64 ,
        eDIMACS::Float64 ,
        preconditioner::Int64,
        erank::Int64,
        aamat::Int64,
        fig_ev::Int64,
        verb::Int64,
        datarank::Int64,
        initpoint::Int64,
        timing::Int64,
        maxit::Int64, 
        datasparsity::Int64,
        model::MyModel
        ) where {T}

        solver = new{T}()
        solver.kit             = kit
        solver.tol_cg          = tol_cg
        solver.tol_cg_up       = tol_cg_up
        solver.tol_cg_min      = tol_cg_min
        solver.eDIMACS         = eDIMACS
        solver.preconditioner  = preconditioner
        solver.erank           = erank
        solver.aamat           = aamat
        solver.fig_ev          = fig_ev
        solver.verb            = verb   
        solver.datarank        = datarank
        solver.initpoint       = initpoint   
        solver.timing          = timing
        solver.maxit           = maxit 
        solver.datasparsity    = datasparsity
        solver.model           = model
        return solver
    end
end

mutable struct Halpha
    kit
    Umat
    Z
    cholS
    AAAATtau
    AAAATtau_fact
    function Halpha(
        kit::Int64
    )
    halpha = new()
    halpha.kit             = kit
    return halpha
    end
end


include("initial_point.jl")
include("prepare_W.jl") 
include("predictor_corrector.jl")

const DEFAULT_OPTIONS = Dict{String,Any}(
    "kit" => 0,
    "tol_cg" => 1.0e-2,
    "tol_cg_up" => 0.5,
    "tol_cg_min" => 1.0e-7,
    "eDIMACS" => 1.0e-7,
    "preconditioner" => 1,
    "erank" => 1,
    "aamat" => 1,
    "fig_ev" => 0,
    "verb" => 1,
    "datarank" => 0,
    "initpoint" => 0,
    "timing" => 1,
    "maxit" => 100,
    "datasparsity" => 8,
)

function load(model, options::Dict; T = Float64)

    kit = Int64(get(options, "kit", 0))
    tol_cg = get(options, "tol_cg", 1.0e-2)
    tol_cg_up = get(options, "tol_cg_up", 0.5)
    tol_cg_min = get(options, "tol_cg_min", 1.0e-7)
    eDIMACS = get(options, "eDIMACS", 1.0e-7)
    preconditioner = Int64(get(options, "preconditioner", 1))
    erank = Int64(get(options, "erank", 1))
    aamat = Int64(get(options, "aamat", 1))
    fig_ev = Int64(get(options, "fig_ev", 0))
    verb = Int64(get(options, "verb", 1))
    datarank = Int64(get(options, "datarank", 0))
    initpoint = Int64(get(options, "initpoint", 0))
    timing = Int64(get(options, "timing", 1))
    maxit = Int64(get(options, "maxit", 100))
    datasparsity = Int64(get(options, "datasparsity", 8))

    solver = MySolver{T}(kit,
        tol_cg,
        tol_cg_up,
        tol_cg_min,
        eDIMACS,
        preconditioner,
        erank,
        aamat,
        fig_ev,
        verb,
        datarank,
        initpoint,
        timing,
        maxit, 
        datasparsity,
        MyModel(model.A,
            model.AA,
            model.B,
            model.C,
            model.nzA,
            model.sigmaA,
            model.qA,
            model.b,
            model.b_const,
            model.d_lin,
            model.C_lin,
            model.n,
            model.msizes,
            model.nlin,
            model.nlmi
        )
    )

    halpha = Halpha(kit)
    solver.cg_iter_tot = 0

    if verb > 0
        t1 = time()
        @printf("\n *** Loraine.jl v0.2.8 ***\n")
        @printf(" *** Initialisation STARTS\n")
    end

    if verb > 0
        @printf(" Number of variables: %5d\n",model.n)
        @printf(" LMI constraints    : %5d\n",model.nlmi)
        if model.nlmi>0
            @printf(" Matrix size(s)     :")
            Printf.format.(Ref(stdout), Ref(Printf.Format("%6d")), model.msizes);
            @printf("\n")
        end
        @printf(" Linear constraints : %5d\n",model.nlin)
        if solver.kit>0
            @printf(" Preconditioner     : %5d\n",preconditioner)
        else
            @printf(" Preconditioner     :  none, using direct solver\n")
        end
    end

    # Input parameters check
    if kit < 0 || kit > 1
        solver.kit = 0
        @printf(" ---Parameter kit out of range, setting kit = %1d\n", solver.kit)
    end
    if tol_cg < tol_cg_min && kit == 1
        solver.tol_cg = tol_cg_min
        @printf(" ---Parameter tol_cg smaller than tol_cg_min, setting tol_cg = %7.1e\n", solver.tol_cg)
    end
    if tol_cg_min > eDIMACS && kit == 1
        solver.tol_cg_min = eDIMACS
        @printf(" ---Parameter tol_cg_min switched to eDIMACS = %7.1e\n", eDIMACS)
    end
    if kit == 1 && (preconditioner < 0 || preconditioner > 4)
        solver.preconditioner = 1
        @printf(" ---Parameter preconditioner out of range, setting preconditioner = %1d\n", solver.preconditioner)
    end
    if erank < 0 
        solver.erank = 1
        @printf(" ---Parameter erank negative, setting erank = %1d\n", solver.erank)
    end
    if datarank < -1 
        solver.datarank = 0
        @printf(" ---Parameter datarank out of range, setting datarank = %1d\n", solver.datarank)
    end
    if initpoint < 0 || initpoint > 1
        solver.initpoint = 1
        @printf(" ---Parameter kit out of range, setting initpoint = %1d\n", solver.initpoint)
    end

    # @show model.A
    # @show size(model.A,1)
    # if min(size(model.A,1),size(model.A,2)) < 1
    #     solver.status = 0
    #     @show size(model.A)
    #     error("Data A empty")
    # end

    return solver, halpha
end

function solve(solver::MySolver,halpha::Halpha)
    t1 = time()
    if solver.verb > 0
        @printf(" *** IP STARTS\n")
        if solver.verb < 2
            if solver.kit == 0
                @printf(" it        obj         error     CPU/it\n")
            else
                @printf(" it        obj         error     cg_iter   CPU/it\n")
            end
        else
            if solver.kit == 0
                @printf(" it        obj         error      err1      err2      err3      err4      err5      err6     CPU/it\n")
                @printf("                                p-eq-con   p-feas   d-eq-con   d-feas     d-gap  slackness         \n")
                @printf("---------------------------------------------------------------------------------------------------\n")
            else
                @printf(" it        obj         error      err1      err2      err3      err4      err5      err6    cg_pre  cg_cor  CPU/it\n")
            end
        end
    end

    setup_solver(solver::MySolver,halpha::Halpha)

    initial_point(solver)

    while solver.status == 0 

        t2 = time()
        myIPstep(solver,halpha)
        solver.itertime = time()-t2

        solver.tol_cg = max(solver.tol_cg * solver.tol_cg_up, solver.tol_cg_min)

        check_convergence(solver)

        if solver.preconditioner == 4
            #         if (cg_iter2>erank*nlmi*sqrt(n)/1 && iter>sqrt(n)/60)||cg_iter2>100 %for SNL problems
            if (solver.cg_iter_cor / 2 > solver.erank * solver.model.nlmi * sqrt(solver.model.n)/20 && solver.iter > sqrt(solver.model.n) / 60) || solver.cg_iter_cor > 100
                solver.preconditioner = 1; solver.aamat = 2; 
                if solver.verb > 0
                    println("Switching to preconditioner 1")
                end
            end
        end

    end

    solver.tottime = time() - t1
    if solver.verb > 0
        if solver.kit == 1
            @printf(" *** Total CG iterations: %8.0d \n", solver.cg_iter_tot)
        end
        if solver.status == 1
            @printf(" *** Optimal solution found in %8.2f seconds\n", solver.tottime)
        end
    end

end

function setup_solver(solver::MySolver{T},halpha::Halpha) where {T}

    solver.X = Matrix{T}[]
    solver.S = Matrix{T}[]
    solver.y = Vector{T}[]

    solver.delX = Matrix{T}[]
    solver.delS = Matrix{T}[]

    solver.D = Vector{T}[]
    solver.G = Matrix{T}[]
    solver.Gi = Matrix{T}[]
    solver.W = Matrix{T}[]
    solver.Si = Matrix{T}[]
    solver.DDsi = Vector{T}[]

    solver.Rd = Matrix{T}[]

    solver.alpha = zeros(solver.model.nlmi)
    solver.beta = zeros(solver.model.nlmi)

    solver.Xn = Matrix{T}[]
    solver.Sn = Matrix{T}[]
    solver.RNT = Matrix{T}[]

    solver.work_m2 = Vector{T}[]
    solver.work_mm = Matrix{T}[]

    solver.regcount = 0

    for i = 1:solver.model.nlmi
        m = solver.model.msizes[i]
        push!(solver.X,zeros(T, m, m))
        push!(solver.S,zeros(T, m, m))
        push!(solver.delX,zeros(T, m, m))
        push!(solver.delS,zeros(T, m, m))
        push!(solver.D, zeros(T, m))
        push!(solver.G,zeros(T, m, m))
        push!(solver.Gi,zeros(T, m, m))
        push!(solver.W,zeros(T, m, m))
        push!(solver.Si,zeros(T, m, m))
        push!(solver.DDsi,zeros(T, m))
        push!(solver.Rd,zeros(T, m, m))
        push!(solver.Xn,zeros(T, m, m))
        push!(solver.Sn,zeros(T, m, m))
        push!(solver.RNT,zeros(T, m, m))
        push!(solver.work_m2, Vector{T}(undef, m*m))
        push!(solver.work_mm, Matrix{T}(undef, m, m))
    end

    solver.norm_b = Float64(norm(solver.model.b))
    solver.norm_C = [Float64(norm(solver.model.C[i])) for i in 1:solver.model.nlmi]
    solver.norm_d = solver.model.nlin > 0 ? Float64(norm(solver.model.d_lin)) : 0.0
    solver.Rp = Vector{T}(undef, solver.model.n)

    halpha.Umat = Matrix{T}[]
    halpha.Z = Matrix{T}[]
    halpha.AAAATtau = SparseMatrixCSC{T}[]

    for i = 1:solver.model.nlmi
        push!(halpha.Umat,zeros(solver.model.msizes[i], solver.erank))
        push!(halpha.Z,zeros(solver.model.msizes[i], solver.model.msizes[i]))
        # tmp = Matrix(I(solver.model.msizes[i]))
        # push!(halpha.cholS,cholesky(tmp))
        push!(halpha.AAAATtau,spzeros(solver.model.n, solver.model.n))
    end

    if solver.kit == 1
        if solver.model.nlmi == 0
            if solver.verb > 0
                println("WARNING: Switching to a direct solver, no LMIs")
            end
            solver.kit = 0
        elseif solver.model.nlmi > 0 && solver.erank >= maximum(solver.model.msizes) - 1
            if solver.verb > 0
                println("WARNING: Switching to a direct solver, erank bigger than matrix size")
            end
            solver.kit = 0
        end
    end

    # when datarank was set to -1 and conversion failed, we switch to datarank = 0
    if ~isempty(solver.model.B)
        if solver.model.nlmi > 0
            for ilmi = 1:solver.model.nlmi
                if nnz(solver.model.B[ilmi]) == 0
                    solver.datarank = 0
                end
            end
        end
    end

end

function myIPstep(solver::MySolver{T},halpha::Halpha) where {T}
    solver.iter += 1
    if solver.iter > solver.maxit
        solver.status = 4
        if solver.verb > 0
            println("WARNING: Stopped by iteration limit (stopping status = 4)")
        end
    end
    solver.cg_iter_pre = 0
    solver.cg_iter_cor = 0
    
    find_mu(solver)

    # @timeit solver.to "prepare W" begin
    prepare_W(solver)
    # end

    ## predictor
    @timeit solver.to "predictor" begin
    predictor(solver,halpha::Halpha)
    end

    sigma_update(solver)

    ## corrector
    @timeit solver.to "corrector" begin
    corrector(solver,halpha)
    end

end

function find_mu(solver)
    trXS = zero(eltype(eltype(solver.X)))
    if solver.model.nlmi > 0
        for i = 1:solver.model.nlmi
            trXS += dot(solver.X[i], solver.S[i])
        end
    end
    mu = trXS

    if solver.model.nlin > 0
        mu += dot(solver.X_lin, solver.S_lin)
    end
    solver.mu = mu / (sum(solver.model.msizes) + solver.model.nlin)
    return solver.mu
end

function check_convergence(solver)

    # DIMACS error evaluation
    solver.err1 = norm(solver.Rp) / (1 + solver.norm_b)
    solver.err2 = solver.err3 = solver.err4 = solver.err5 = solver.err6 = 0.0
    btrace_CX = btrace(solver.model.nlmi, solver.model.C, solver.X)
    b_dot_y = dot(solver.model.b, solver.y)
    inv_1pnb = 1 / (1 + solver.norm_b)
    if solver.model.nlmi > 0
        nlmi = solver.model.nlmi
        err2_v = Vector{Float64}(undef, nlmi)
        err3_v = Vector{Float64}(undef, nlmi)
        err4_v = Vector{Float64}(undef, nlmi)
        err6_v = Vector{Float64}(undef, nlmi)
        Threads.@threads for i = 1:nlmi
            inv_1pnC = 1 / (1 + solver.norm_C[i])
            err2_v[i] = max(0.0, -minimum(eigvals(Symmetric(solver.X[i]))) * inv_1pnb)
            err3_v[i] = norm(solver.Rd[i], 2) * inv_1pnC
            err4_v[i] = max(0.0, -minimum(eigvals(Symmetric(solver.S[i]))) * inv_1pnC)
            err6_v[i] = dot(solver.S[i], solver.X[i]) / (1 + abs(dot(solver.model.C[i], solver.X[i])) + abs(b_dot_y))
        end
        solver.err2 = sum(err2_v)
        solver.err3 = sum(err3_v)
        solver.err4 = sum(err4_v)
        solver.err6 = sum(err6_v)
    end

    solver.err5 = (btrace_CX - b_dot_y) / (1 + abs(btrace_CX) + abs(b_dot_y))
    if solver.model.nlin > 0
        solver.err2 += max(0.0, -minimum(solver.X_lin) * inv_1pnb)
        solver.err3 += norm(solver.Rd_lin) / (1 + solver.norm_d)
        solver.err4 += max(0.0, -minimum(solver.S_lin) / (1 + solver.norm_d))
        solver.err5 = (btrace_CX + dot(solver.model.d_lin, solver.X_lin) - b_dot_y) / (1 + abs(btrace_CX) + abs(b_dot_y))
        solver.err6 += dot(solver.S_lin, solver.X_lin) / (1 + abs(dot(solver.model.d_lin, solver.X_lin)) + abs(b_dot_y))
    end

    if solver.model.nlmi > 0
        DIMACS_error = solver.err1 + solver.err2 + solver.err3 + solver.err4 + abs(solver.err5) + solver.err6
    else
        DIMACS_error = solver.err2 + solver.err3 + solver.err4 + abs(solver.err5) + solver.err6
    end
    if solver.verb > 0 && solver.status == 0 
        #@sprintf("%3.0d %16.8e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %8.0d %9.0d %8.1e %6.0d %8.2f\n', iter, y[1:ddnvar]"*ddc[:], DIMACS_error, err1, err2, err3, err4, err5, err6, cg_iter1, cg_iter2, eq_norm, arank, titi)
        # @printf("%3.0d %16.8e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %8.0d %9.0d %6.0d\n", iter, dot(y, ctmp'), DIMACS_error, err1, err2, err3, err4, err5, err6, cg_iter1, cg_iter2, cg_iter2)
        if solver.verb > 1
            if solver.kit == 0
                @printf("%3.0d %16.8e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %8.2f\n", solver.iter, -dot(solver.y, solver.model.b') + solver.model.b_const, DIMACS_error, solver.err1, solver.err2, solver.err3, solver.err4, solver.err5, solver.err6,solver.itertime)
            else
                @printf("%3.0d %16.8e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %9.2e %7.0d %7.0d %8.2f\n", solver.iter, -dot(solver.y, solver.model.b') + solver.model.b_const, DIMACS_error, solver.err1, solver.err2, solver.err3, solver.err4, solver.err5, solver.err6, solver.cg_iter_pre, solver.cg_iter_cor,solver.itertime)
            end    
    else
            if solver.kit == 0
                @printf("%3.0d %16.8e %9.2e %8.2f\n", solver.iter, -dot(solver.y, solver.model.b') + solver.model.b_const, DIMACS_error, solver.itertime)
            else
                @printf("%3.0d %16.8e %9.2e %9.0d %8.2f\n", solver.iter, -dot(solver.y, solver.model.b') + solver.model.b_const, DIMACS_error, solver.cg_iter_pre + solver.cg_iter_cor, solver.itertime)
            end
        end
    end

    if DIMACS_error < solver.eDIMACS
        solver.status = 1
        if solver.verb > 0
            println("Primal objective: ", -b_dot_y + solver.model.b_const)
            if solver.model.nlin > 0
                println("Dual objective:   ", -btrace_CX - dot(solver.model.d_lin, solver.X_lin) + solver.model.b_const)
            else
                println("Dual objective:   ", -btrace_CX + solver.model.b_const)
            end
        end
    end

    if DIMACS_error > 1e55 
        solver.status = 2
        if solver.verb > 0
            println("WARNING: Problem probably infeasible (stopping status = 2)")
        end
    elseif DIMACS_error > 1e55 || abs(dot(solver.y, solver.model.b')) > 1e55
        solver.status = 3
        if solver.verb > 0
            println("WARNING: Problem probably unbounded or infeasible (stopping status = 3)")
        end
    end

end

```Functions for the iterative solver follow```

struct MyA{T}
    W::Vector{Matrix{T}}
    AA::Vector{SparseArrays.SparseMatrixCSC{Float64,Int}}
    nlin::Int64
    C_lin::SparseArrays.SparseMatrixCSC{Float64,Int64}
    X_lin
    S_lin_inv
    to::TimerOutputs.TimerOutput
    # preallocated workspace, reused across every CG iteration
    ax1::Vector{T}
    axvec::Vector{Vector{T}}
    axmat::Vector{Matrix{T}}
    waxwtmp::Vector{Matrix{T}}
    waxw::Vector{Matrix{T}}
    XSi::Vector{T}
    Ctx::Vector{T}
    tmp_nlin::Vector{T}
end

function MyA(W::Vector{Matrix{T}}, AA, nlin::Int64, C_lin, X_lin, S_lin_inv, to) where {T}
    nlmi = length(AA)
    ax1 = zeros(T, size(AA[1], 1))
    axvec = [Vector{T}(undef, size(AA[ilmi], 2)) for ilmi in 1:nlmi]
    axmat = [Matrix{T}(undef, size(W[ilmi])) for ilmi in 1:nlmi]
    waxwtmp = [Matrix{T}(undef, size(W[ilmi])) for ilmi in 1:nlmi]
    waxw = [Matrix{T}(undef, size(W[ilmi])) for ilmi in 1:nlmi]
    XSi = Vector{T}(undef, nlin)
    if nlin > 0
        XSi .= X_lin .* S_lin_inv
    end
    Ctx = Vector{T}(undef, nlin)
    tmp_nlin = Vector{T}(undef, nlin)
    return MyA{T}(W, AA, nlin, C_lin, X_lin, S_lin_inv, to, ax1, axvec, axmat, waxwtmp, waxw, XSi, Ctx, tmp_nlin)
end

function (t::MyA)(Ax::Vector{T}, x::Vector{T}) where {T}
    @timeit t.to "Ax" begin
    nlmi = length(t.AA)
    fill!(t.ax1, zero(T))
    if nlmi > 0
        for ilmi = 1:nlmi
            mul!(t.axvec[ilmi], transpose(t.AA[ilmi]), x)
            mat!(t.axmat[ilmi], t.axvec[ilmi])
            mul!(t.waxwtmp[ilmi], t.W[ilmi], t.axmat[ilmi])
            mul!(t.waxw[ilmi], t.waxwtmp[ilmi], t.W[ilmi])
            mul!(t.ax1, t.AA[ilmi], vec(t.waxw[ilmi]), true, true)
        end
    end
    if t.nlin>0
        mul!(t.Ctx, t.C_lin', x)
        t.tmp_nlin .= t.XSi .* t.Ctx
        mul!(t.ax1, t.C_lin, t.tmp_nlin, true, true)
    end

    copyto!(Ax, t.ax1)
    end
end

struct MyM_no
    to::TimerOutputs.TimerOutput
end

function (t::MyM_no)(Mx::Vector{T}, x::Vector{T}) where {T}
    copy!(Mx,x)
end

function Prec_for_CG_beta(solver,halpha)    
    
    nlmi = solver.model.nlmi
    kk = solver.erank .* ones(Int64,nlmi,1)  
    nvar = solver.model.n
        
    ntot=0
    if nlmi > 0
        for ilmi=1:nlmi
            ntot = ntot + size(solver.W[ilmi],1)
        end
    end
    
    halpha.AAAATtau = zeros(nvar)
    if nlmi > 0
        for ilmi = 1:nlmi
            n = size(solver.W[ilmi],1);
            k = kk[ilmi];
            F = eigen(solver.W[ilmi]); 
            lambdaf = F.values 
            lambda_s = lambdaf[1:n-k]

            if solver.aamat == 0
                ttau = 1.0 * minimum(lambda_s)
            else
                ttau = (minimum(lambda_s) + mean(lambda_s))/2.0 - 1.0e-14
            end
            if solver.aamat < 3
                ZZZ = ones(nvar)
            else
                ZZZ = spzeros(nvar,1)
            end
            
            halpha.AAAATtau += ttau^2 .* ZZZ
        end
        if solver.model.nlin > 0
            halpha.AAAATtau .+= diag(solver.model.C_lin * Diagonal(solver.X_lin .* solver.S_lin_inv) * solver.model.C_lin')
        end
    end
end

struct MyM_beta
    AA
    AAAATtau
end

function (t::MyM_beta)(Mx::Vector{T}, x::Vector{T}) where {T}
    @. Mx = x / t.AAAATtau
end

function Prec_for_CG_tilS_prep(solver::MySolver{T},halpha) where {T} 
    
    @timeit solver.to "prec" begin
    nlmi = solver.model.nlmi
    kk = solver.erank .* ones(Int64,nlmi,1)
    # kk[2] = 3
    # halpha.Z = SparseMatrixCSC{T}[]
    halpha.Z = Matrix{T}[]

    nvar = solver.model.n
    
    halpha.AAAATtau = spzeros(nvar,nvar)
    
    ntot=0
    if nlmi > 0
        for ilmi=1:nlmi
            ntot = ntot + size(solver.W[ilmi],1)
        end
    end
    sizeS=0
    if nlmi > 0
        for ilmi=1:nlmi
            sizeS += kk[ilmi] * size(solver.W[ilmi],1)
        end
    end
    
    lbt = 1; lbs=1;
    if nlmi > 0
        for ilmi = 1:nlmi
            n = size(solver.W[ilmi],1);
            k = kk[ilmi];
            
            F = eigen(Float64.(solver.W[ilmi])); 
            vectf = F.vectors
            lambdaf = F.values 

            vect_l = vectf[:,n-k+1:n]
            lambda_l = lambdaf[n-k+1:n]
            vect_s = vectf[:,1:n-k]
            lambda_s = lambdaf[1:n-k]

            if solver.aamat == 0
                ttau = 1.0 * minimum(lambda_s)
            else
                ttau = (minimum(lambda_s) + mean(lambda_s))/2 - 1.0e-14
            end
            
            halpha.Umat[ilmi] = vect_l .* sqrt.(lambda_l .- ttau)'
            
            # @timeit solver.to "prec1" begin
            W0 = [vect_s vect_l]*[spdiagm(lambda_s[:]) spzeros(n-k,k); spzeros(k,n-k) ttau * I(k)] * [vect_s vect_l]'
            # end

            # @timeit solver.to "prec2" begin
            W0 = @. (W0 + W0') / 2
            Ztmp = cholesky(2 .* W0 + halpha.Umat[ilmi] * halpha.Umat[ilmi]')
            push!(halpha.Z,Ztmp.L)
            # end
            
            if solver.aamat < 3
                halpha.AAAATtau += ttau^2 * I(nvar)
            end
        end
    end
    
    if solver.model.nlin > 0
        halpha.AAAATtau .+= solver.model.C_lin * Diagonal(solver.X_lin .* solver.S_lin_inv) * solver.model.C_lin'
    end

    # Factorize once here; `AAAATtau` is constant for the whole predictor/corrector
    # CG solve, so this avoids re-factorizing it on every single CG iteration.
    halpha.AAAATtau_fact = factorize(halpha.AAAATtau)

    didi = 0
    for ilmi = 1:nlmi
        didi += size(solver.W[ilmi],1)
    end
    k = kk[1]
    if k > 1 #slow formula
        # @timeit solver.to "prec3" begin
        t = zeros(nvar, k*didi)
        if nlmi > 0
            for ilmi = 1:nlmi
                n = size(solver.W[ilmi],1)
                k = kk[ilmi]
                TT = kron(halpha.Umat[ilmi],halpha.Z[ilmi])
                t[1:nvar,lbt:lbt+k*n-1] .= solver.model.AA[ilmi] * TT
                lbt = lbt + k*n
            end
        end
        # end
        
        @timeit solver.to "prec4" begin
        S = t' * (halpha.AAAATtau_fact \ t)
        end
    else #fast formula
        AAAATtau_d = spdiagm(sqrt.(1 ./ diag(halpha.AAAATtau)));

        # @timeit solver.to "prec3" begin
        # t = zeros(nvar, k*didi)
        # if nlmi > 0
        #     for ilmi = 1:nlmi
        #         if kk[ilmi] == 0
        #             continue 
        #         end
        #         n = size(solver.W[ilmi],1) 
        #         k = kk[ilmi] 
        #         AAs = AAAATtau_d * solver.model.AA[ilmi]
        #         ii_, jj_, aa_ = findnz(AAs)
        #         qq_ = floor.(Int64,(jj_ .- 1) ./ n) .+ 1
        #         pp_ = mod.(jj_ .- 1, n) .+ 1
        #         UU = halpha.Umat[ilmi][qq_]
        #         aau = aa_ .* UU
        #         AU = sparse(ii_,pp_,aau,nvar,n)
        #         if nlmi>1
        #             t[1:nvar,lbt:lbt+k*n-1] .= AU * halpha.Z[ilmi]
        #         else
        #             t .= AU * halpha.Z[1]
        #         end
        #         lbt = lbt + k*n
        #     end 
        # end
        # S .= (t' * t)
        # # mul!(S,t',t)
        # end

        S, lbt = prec_alpha_S!(solver,halpha,AAAATtau_d,kk,didi,lbt,sizeS)
    end
    
    # Schur complement for the SMW formula
    S = @. (S + S') / 2
    S += I(size(S, 1))
    halpha.cholS = cholesky(S)

    end
       
end

struct MyM{T}
    AA
    AAAATtau_fact
    Umat::Vector{Matrix{T}}
    Z::Vector{Matrix{T}}
    cholS
    # preallocated workspace, reused across every CG iteration
    AAAAinvx::Vector{T}
    yy2::Vector{T}
    yyy2::Vector{T}
    y33::Vector{T}
    y33_sol::Vector{T}
    offsets::Vector{Int}
    y22::Vector{Vector{T}}
    y22mat::Vector{Matrix{T}}
    ZY::Vector{Matrix{T}}
    chunk::Vector{Matrix{T}}
    xx::Vector{Vector{T}}
    outer::Vector{Matrix{T}}
    yy::Vector{Vector{T}}
end

function MyM(AA, AAAATtau_fact, Umat::Vector{Matrix{T}}, Z::Vector{Matrix{T}}, cholS) where {T}
    nlmi = length(AA)
    nvar = size(AA[1], 1)

    offsets = Vector{Int}(undef, nlmi)
    offset = 0
    for ilmi = 1:nlmi
        offsets[ilmi] = offset
        offset += size(Z[ilmi], 1) * size(Umat[ilmi], 2)
    end
    sizeS = offset

    y22 = [Vector{T}(undef, size(AA[ilmi], 2)) for ilmi in 1:nlmi]
    y22mat = [Matrix{T}(undef, size(Umat[ilmi], 1), size(Umat[ilmi], 1)) for ilmi in 1:nlmi]
    ZY = [Matrix{T}(undef, size(Umat[ilmi], 1), size(Umat[ilmi], 1)) for ilmi in 1:nlmi]
    chunk = [Matrix{T}(undef, size(Umat[ilmi], 1), size(Umat[ilmi], 2)) for ilmi in 1:nlmi]
    xx = [Vector{T}(undef, size(Umat[ilmi], 1)) for ilmi in 1:nlmi]
    outer = [Matrix{T}(undef, size(Umat[ilmi], 1), size(Umat[ilmi], 1)) for ilmi in 1:nlmi]
    yy = [Vector{T}(undef, size(Umat[ilmi], 1)^2) for ilmi in 1:nlmi]

    return MyM{T}(AA, AAAATtau_fact, Umat, Z, cholS,
        Vector{T}(undef, nvar), Vector{T}(undef, nvar), Vector{T}(undef, nvar),
        Vector{T}(undef, sizeS), Vector{T}(undef, sizeS),
        offsets, y22, y22mat, ZY, chunk, xx, outer, yy)
end

function prec_alpha_S!(solver::MySolver{T},halpha,AAAATtau_d,kk,didi,lbt,sizeS) where {T}
    @timeit solver.to "prec3" begin
    S = Matrix{T}(undef,sizeS,sizeS)
    nvar = solver.model.n
    t = Matrix{T}(undef,nvar,kk[1]*didi)
    if solver.model.nlmi > 0
        for ilmi = 1:solver.model.nlmi
            if kk[ilmi] == 0
                continue 
            end
            n = size(solver.W[ilmi],1) 
            k = kk[ilmi] 

            @timeit solver.to "prec30" begin
            AAs = AAAATtau_d * solver.model.AA[ilmi]
            end
            # @timeit solver.to "prec31" begin
            ii_, jj_, aa_ = findnz(AAs)
            qq_ = floor.(Int64,(jj_ .- 1) ./ n) .+ 1
            pp_ = mod.(jj_ .- 1, n) .+ 1
            aau = Vector{T}(undef,length(aa_))
            aau .= aa_ .* halpha.Umat[ilmi][qq_]
            AU = sparse(ii_,pp_,aau,nvar,n)
            # end
            if solver.model.nlmi>1
                # @timeit solver.to "prec32" begin
                didi1 = size(solver.W[ilmi],1)
                ttmp = Matrix{T}(undef,nvar,kk[ilmi]*didi1)
                mul!(ttmp, AU, halpha.Z[ilmi])
                t[1:nvar,lbt:lbt+k*n-1] = ttmp
                # end
            else
                # @timeit solver.to "prec32" begin
                mul!(t, AU, halpha.Z[1])
                # end
            end
            lbt = lbt + k*n
        end 
    end
    @timeit solver.to "prec33" begin
    mul!(S , t', t)
    end
end

return S, lbt
end

function (t::MyM)(Mx::Vector{T}, x::Vector{T}) where {T}

    nlmi = length(t.AA)

    ldiv!(t.AAAAinvx, t.AAAATtau_fact, x)

    if nlmi > 0
        for ilmi = 1:nlmi
            mul!(t.y22[ilmi], t.AA[ilmi]', t.AAAAinvx)
            mat!(t.y22mat[ilmi], t.y22[ilmi])
            mul!(t.ZY[ilmi], t.Z[ilmi]', t.y22mat[ilmi])
            mul!(t.chunk[ilmi], t.ZY[ilmi], t.Umat[ilmi])
            off = t.offsets[ilmi]
            n_chunk = length(t.chunk[ilmi])
            t.y33[off+1:off+n_chunk] .= vec(t.chunk[ilmi])
        end
    end

    ldiv!(t.y33_sol, t.cholS, t.y33)

    fill!(t.yy2, zero(T))
    if nlmi > 0
        for ilmi = 1:nlmi
            n = size(t.Umat[ilmi],1)
            k = size(t.Umat[ilmi],2)
            off = t.offsets[ilmi]
            fill!(t.yy[ilmi], zero(T))
            for i = 1:k
                mul!(t.xx[ilmi], t.Z[ilmi], @view(t.y33_sol[off+(i-1)*n+1:off+i*n]))
                t.outer[ilmi] .= t.xx[ilmi] .* (@view(t.Umat[ilmi][:,i]))'
                t.yy[ilmi] .+= vec(t.outer[ilmi])
            end
            mul!(t.yy2, t.AA[ilmi], t.yy[ilmi], true, true)
        end
    end

    ldiv!(t.yyy2, t.AAAATtau_fact, t.yy2)

    @. Mx = t.AAAAinvx - t.yyy2

end

end #module

using MathOptInterface
const MOI = MathOptInterface

const VAF = MOI.VectorAffineFunction{Float64}
const PSD = MOI.PositiveSemidefiniteConeTriangle
const NNG = MOI.Nonnegatives

MOI.Utilities.@product_of_sets(NNGCones, NNG)

MOI.Utilities.@product_of_sets(PSDCones, PSD)

MOI.Utilities.@struct_of_constraints_by_set_types(PSDOrNot, PSD, NNG)

const OptimizerCache = MOI.Utilities.GenericModel{
    Float64,
    MOI.Utilities.ObjectiveContainer{Float64},
    MOI.Utilities.VariablesContainer{Float64},
    PSDOrNot{Float64}{
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Int64,
                MOI.Utilities.OneBasedIndexing,
            },
            Vector{Float64},
            PSDCones{Float64},
        },
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Int64,
                MOI.Utilities.OneBasedIndexing,
            },
            Vector{Float64},
            NNGCones{Float64},
        },
    },
}

mutable struct Optimizer{T} <: MOI.AbstractOptimizer
    solver::Union{Nothing,MySolver{T}}
    halpha::Union{Nothing,Halpha}
    lmi_id::Dict{MOI.ConstraintIndex{VAF,PSD},Int64}
    lin_cones::Union{Nothing,NNGCones{Float64}}
    max_sense::Bool
    objective_constant::Float64
    silent::Bool
    options::Dict{String,Any}

    function Optimizer{T}() where {T}
        return new{T}(
            nothing,
            nothing,
            Dict{MOI.ConstraintIndex{VAF,PSD},Int64}(),
            nothing,
            false,
            0.0,
            false,
            copy(Solvers.DEFAULT_OPTIONS),
        )
    end
end

Optimizer() = Optimizer{Float64}()

function MOI.default_cache(::Optimizer, ::Type{Float64})
    return MOI.Utilities.UniversalFallback(OptimizerCache())
end

function MOI.is_empty(optimizer::Optimizer)
    return isnothing(optimizer.solver)
end

function MOI.empty!(optimizer::Optimizer)
    optimizer.solver = nothing
    optimizer.lin_cones = nothing
    return
end

MOI.get(::Optimizer, ::MOI.SolverName) = "Loraine"

# MOI.RawOptimizerAttribute

function MOI.supports(::Optimizer, param::MOI.RawOptimizerAttribute)
    return haskey(Solvers.DEFAULT_OPTIONS, param.name)
end

function MOI.set(optimizer::Optimizer, param::MOI.RawOptimizerAttribute, value)
    if !MOI.supports(optimizer, param)
        throw(MOI.UnsupportedAttribute(param))
    end
    optimizer.options[param.name] = value
    return
end

function MOI.get(optimizer::Optimizer, param::MOI.RawOptimizerAttribute)
    if !MOI.supports(optimizer, param)
        throw(MOI.UnsupportedAttribute(param))
    end
    return optimizer.options[param.name]
end

# MOI.Silent

MOI.supports(::Optimizer, ::MOI.Silent) = true

function MOI.set(optimizer::Optimizer, ::MOI.Silent, value::Bool)
    optimizer.silent = value
    return
end

MOI.get(optimizer::Optimizer, ::MOI.Silent) = optimizer.silent

function MOI.set(optimizer::Optimizer, ::MOI.ObjectiveSense, value::Bool)
    optimizer.max_sense = value
    return
end

# MOI.supports

function MOI.supports(
    ::Optimizer,
    ::Union{MOI.ObjectiveSense,MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}},
)
    return true
end

const SUPPORTED_CONES = Union{NNG,PSD}

function MOI.supports_constraint(::Optimizer, ::Type{VAF}, ::Type{<:SUPPORTED_CONES})
    return true
end

function MOI.optimize!(optimizer::Optimizer)
    optimizer.solver.to = TimerOutput()
    solve(optimizer.solver, optimizer.halpha)
    return
end

function MOI.copy_to(dest::Optimizer{T}, src::OptimizerCache) where {T}
    MOI.empty!(dest)
    psd_AC = MOI.Utilities.constraints(src.constraints, VAF, PSD)
    Cd_lin = MOI.Utilities.constraints(src.constraints, VAF, NNG)
    SM = SparseMatrixCSC{Float64,Int64}
    psd_A = convert(SM, psd_AC.coefficients)
    C_lin = convert(SM, Cd_lin.coefficients)
    C_lin = -convert(SM, C_lin')
    n = MOI.get(src, MOI.NumberOfVariables())
    nlmi = MOI.get(src, MOI.NumberOfConstraints{VAF,PSD}())
    A = Matrix{Tuple{Vector{Int64},Vector{Int64},Vector{Float64},Int64,Int64}}(undef, nlmi, n + 1)
    back = Vector{Tuple{Int64,Int64,Int64}}(undef, size(psd_A, 1))
    empty!(dest.lmi_id)
    row = 0
    msizes = Int64[]
    for (lmi_id, ci) in enumerate(MOI.get(src, MOI.ListOfConstraintIndices{VAF,PSD}()))
        dest.lmi_id[ci] = lmi_id
        set = MOI.get(src, MOI.ConstraintSet(), ci)
        d = set.side_dimension
        push!(msizes, d)
        for k = 1:(n+1)
            A[lmi_id, k] = (Int64[], Int64[], Float64[], d, d)
        end
        for j = 1:d
            for i = 1:j
                row += 1
                back[row] = (lmi_id, i, j)
            end
        end
    end
    function __add(lmi_id, k, i, j, v)
        I, J, V, _, _ = A[lmi_id, k]
        push!(I, i)
        push!(J, j)
        push!(V, v)
        return
    end
    function _add(lmi_id, k, i, j, coef)
        __add(lmi_id, k, i, j, coef)
        if i != j
            __add(lmi_id, k, j, i, coef)
        end
        return
    end
    for row in eachindex(back)
        lmi_id, i, j = back[row]
        _add(lmi_id, 1, i, j, -psd_AC.constants[row])
    end
    for var = 1:n
        for k in nzrange(psd_A, var)
            lmi_id, i, j = back[rowvals(psd_A)[k]]
            col = 1 + var
            _add(lmi_id, col, i, j, nonzeros(psd_A)[k])
        end
    end
    dest.max_sense = MOI.get(src, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    obj = MOI.get(src, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}())
    # objective_constant = MOI.constant(obj) # TODO # MK: done(?)
    b_const = obj.constant
    b_const = dest.max_sense ? -b_const : b_const
    b0 = zeros(n)
    for term in obj.terms
        b0[term.variable.value] += term.coefficient
    end
    b = dest.max_sense ? b0 : -b0
    # b = max_sense ? -b0 : b0

    AA = SparseMatrixCSC{Float64,Int}[sparse(IJV...) for IJV in A]
    drank = get(dest.options,"datarank",1)
    κ = get(dest.options,"datasparsity",1)
    model = MyModel(
        AA,
        Solvers._prepare_A(AA,drank,κ)...,
        b,
        b_const,
        convert(SparseVector{Float64,Int64}, sparsevec(Cd_lin.constants)),
        C_lin,
        n,
        msizes,
        Int64(length(Cd_lin.constants)),
        nlmi,
    )
    # FIXME this does not work if an option is changed between `MOI.copy_to` and `MOI.optimize!`
    options = copy(dest.options)
    if dest.silent
        options["verb"] = 0
    end
    dest.lin_cones = Cd_lin.sets
    dest.solver, dest.halpha = load(model, options; T)
    return MOI.Utilities.identity_index_map(src)
end

function MOI.copy_to(dest::Optimizer, src::MOI.ModelLike)
    cache = OptimizerCache()
    index_map = MOI.copy_to(cache, src)
    MOI.copy_to(dest, cache)
    return index_map
end

function MOI.get(optimizer::Optimizer, ::MOI.SolveTimeSec)
    return optimizer.solver.tottime
end

function MOI.get(optimizer::Optimizer, ::MOI.BarrierIterations)
    return optimizer.solver.iter
end

function MOI.get(optimizer::Optimizer, ::MOI.RawStatusString)
    # TODO I'd probably do an `if`-`else` here like for `MOI.TerminationStatus`
    #      except that here you are free to communicate any message to the user,
    #      you are not constrained to an any like `MOI.TerminationStatus`
    return "Terminated with status $(optimizer.solver.status)"
end

function MOI.get(optimizer::Optimizer, ::MOI.TerminationStatus)
    if isnothing(optimizer.solver) || optimizer.solver.status == 0
        return MOI.OPTIMIZE_NOT_CALLED
    elseif optimizer.solver.status == 1
        return MOI.OPTIMAL
    elseif optimizer.solver.status == 2
        return MOI.INFEASIBLE
    elseif optimizer.solver.status == 3
        return MOI.INFEASIBLE_OR_UNBOUNDED
    else
        @assert optimizer.solver.status == 4
        return MOI.ITERATION_LIMIT
    end
end

function MOI.get(model::Optimizer, attr::MOI.PrimalStatus)
    if attr.result_index != MOI.get(model, MOI.ResultCount())
        return MOI.NO_SOLUTION
    end
    term = MOI.get(model, MOI.TerminationStatus())
    if term == MOI.OPTIMIZE_NOT_CALLED
        return MOI.NO_SOLUTION
    elseif term == MOI.OPTIMAL
        return MOI.FEASIBLE_POINT
    elseif term == MOI.INFEASIBLE
        return MOI.INFEASIBLE_POINT
    elseif term == MOI.INFEASIBLE_OR_UNBOUNDED
        return MOI.UNKNOWN_RESULT_STATUS
    else
        @assert term == MOI.ITERATION_LIMIT
        return MOI.UNKNOWN_RESULT_STATUS
    end
end

function MOI.get(model::Optimizer, attr::MOI.DualStatus)
    if attr.result_index != MOI.get(model, MOI.ResultCount())
        return MOI.NO_SOLUTION
    end
    term = MOI.get(model, MOI.TerminationStatus())
    if term == MOI.OPTIMIZE_NOT_CALLED
        return MOI.NO_SOLUTION
    elseif term == MOI.OPTIMAL
        return MOI.FEASIBLE_POINT
    elseif term == MOI.INFEASIBLE
        # The solution doesn't seem to be a valid `MOI.INFEASIBILITY_CERTIFICATE`,
        # e.g., it's failing `test_infeasible_affine_MIN_SENSE`
        return MOI.UNKNOWN_RESULT_STATUS
    elseif term == MOI.INFEASIBLE_OR_UNBOUNDED
        return MOI.UNKNOWN_RESULT_STATUS
    else
        @assert term == MOI.ITERATION_LIMIT
        return MOI.UNKNOWN_RESULT_STATUS
    end
end

function MOI.get(model::Optimizer, ::MOI.ResultCount)
    if MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        return 0
    else
        return 1
    end
end

function MOI.get(optimizer::Optimizer, attr::MOI.ObjectiveValue)::Float64
    MOI.check_result_index_bounds(optimizer, attr)
    val = dot(optimizer.solver.model.b, optimizer.solver.y) - optimizer.solver.model.b_const
    return optimizer.max_sense ? val : -val
end

function MOI.get(optimizer::Optimizer, attr::MOI.DualObjectiveValue)
    MOI.check_result_index_bounds(optimizer, attr)
    val =
        btrace(optimizer.solver.model.nlmi, optimizer.solver.model.C, optimizer.solver.X) +
        dot(optimizer.solver.model.d_lin, optimizer.solver.X_lin) - optimizer.solver.model.b_const
        return optimizer.max_sense ? val : -val
end

function MOI.get(model::Optimizer, attr::MOI.VariablePrimal, vi::MOI.VariableIndex)
    MOI.check_result_index_bounds(model, attr)
    return model.solver.y[vi.value]
end

function MOI.get(
    optimizer::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{VAF,PSD},
)::Vector{Float64}
    MOI.check_result_index_bounds(optimizer, attr)
    lmi_id = optimizer.lmi_id[ci]
    X = optimizer.solver.X[lmi_id]
    n = optimizer.solver.model.msizes[lmi_id]
    return [X[i, j] for j = 1:n for i = 1:j]
end

function MOI.get(
    optimizer::Optimizer,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{VAF,NNG},
)::Vector{Float64}
    MOI.check_result_index_bounds(optimizer, attr)
    rows = MOI.Utilities.rows(optimizer.lin_cones, ci)
    return optimizer.solver.X_lin[rows]
end

""""Solve a semidefinite optimization problem in SDPA input format by Loraine using JuMP 
(or any other SDP code linked in JuMP)"""

using JuMP
import Loraine 
# import CSDP
# import SCS
# using Mosek
# using MosekTools
# import Hypatia
# using Dualization
using MultiFloats

function read_sdpa(
    filename::String,
    T::Type = Float64,
)
    src = MOI.FileFormats.SDPA.Model{T}()
    MOI.read_from_file(src, filename)
    model = GenericModel{T}()
    MOI.copy_to(model, src)
    return model
end

# model = JuMP.GenericModel{Float64x2}(Loraine.Optimizer)

# Select your semidefinite optimization problem in SDPA input format
# model=read_from_file("/Users/michal/Dropbox/michal/sdplib/Hans/trto2.dat-s")
# model=read_from_file("/Users/michal/Dropbox/michal/sdplib/maxG11.dat-s")
# model=read_from_file("/Users/michal/Dropbox/michal/POEMA/IP/ip-for-low-rank-sdp/database/problems/SDPA/vib5.dat-s")
# model=read_from_file("/Users/michal/Dropbox/michal/j/k.dat-s")

# model=read_sdpa("examples/data/theta1.dat-s")
model=read_sdpa(joinpath(@__DIR__, "data", "theta1.dat-s"))
# model=read_from_file(joinpath(dirname(@__DIR__), "examples/data/theta1.dat-s"))
# model=read_from_file("examples/data/theta1.dat-s")
# model=read_sdpa(joinpath(@__DIR__, "data", "vib9.dat-s"))
# model=read_from_file("examples/data/vib9.dat-s") #use with "datarank = -1"

set_optimizer(model, Loraine.Optimizer{Float64})
# set_optimizer(model, Loraine.Optimizer{Float64x2})

# Loraine options

set_attribute(model, "kit", 1)
set_attribute(model, "tol_cg", 1.0e-2)
set_attribute(model, "tol_cg_min", 1.0e-6)
set_attribute(model, "eDIMACS", 1e-6)
set_attribute(model, "preconditioner", 1)
set_attribute(model, "erank", 1)
set_attribute(model, "aamat", 2)
set_attribute(model, "verb", 1)
set_attribute(model, "datarank", 0)
set_attribute(model, "initpoint", 1)
set_attribute(model, "maxit", Int64(100))
set_attribute(model, "datasparsity", 8)

# set_optimizer(model, CSDP.Optimizer)
optimize!(model)

# solution_summary(model)
using Test
@test objective_value(model) ≈ 23 rtol = 1e-6
# # value.(X)

# Mosek (CSDP, etc) for a comparison
# Mosek must solve the dualized problem to be efficient

# set_optimizer(model, CSDP.Optimizer)
# dual_model = dualize(model, CSDP.Optimizer)
# @time optimize!(dual_model)

# termination_status(model)

# Inspired from https://github.com/jump-dev/JuMP.jl/blob/master/docs/make.jl

using Loraine
using Documenter

makedocs(
    sitename = "Loraine",
    format = Documenter.HTML(prettyurls = get(ENV, "CI", nothing) == "true"),
    pages = [
        "Index" => "index.md",
        "Overview" => "overview.md",
        "Loraine Options" => "Loraine_options.md",
        "Low-rank Solutions" => "low-rank_solutions.md",
        "Low-rank Data" => "low-rank_data.md",
    ],
    # The following ensures that we only include the docstrings from
    # this module for functions define in Base that we overwrite.
    modules = [Loraine]
)

deploydocs(
    repo   = "github.com/kocvara/Loraine.jl.git",
    target = "build",
    push_preview = true,
)

using TimerOutputs
using FameSVD
using MultiFloats

function try_cholesky(solver, X, i::Integer, name::String)
    try
        return cholesky(X[i])
    catch
        if solver.verb > 0
            println("Matrix $name not positive definite, trying to regularize")
        end
        icount = 0
        while isposdef(X[i]) == false
            X[i] += 1e-5 .* I(size(X[i], 1))
            icount += 1
            if icount > 1000
                if solver.verb > 0
                    println("WARNING: $name cannot be made positive definite, giving up")
                end
                solver.status = 4
                return I(size(X[i], 1))
            end
        end
        return cholesky(X[i])
    end
end

function prepare_W(solver::MySolver{T}) where {T}

    @timeit solver.to "prepare_W" begin
    Threads.@threads for i = 1:solver.model.nlmi
        Ctmp = try_cholesky(solver, solver.X, i, "X")
        CtmpS = try_cholesky(solver, solver.S, i, "S")
        CCtmp = Matrix{T}(undef, size(CtmpS.L, 1), size(CtmpS.L, 1))
        mul!(CCtmp, (CtmpS.L)', Ctmp.L)
        if T == Float64
            _, Dtmp, V = fsvd(CCtmp)
        else
            _, Dtmp, V = svd(CCtmp)
        end

        solver.D[i] = copy(Dtmp)
        Di2 = try
            Diagonal(1.0 ./ sqrt.(Dtmp))
        catch
            println("WARNING: Numerical difficulties, giving up")
            solver.status = 4
            Diagonal(ones(T, length(Dtmp)))
        end

        solver.G[i] = Ctmp.L * V * Di2
        solver.Gi[i] = inv(solver.G[i])
        solver.W[i] = solver.G[i] * solver.G[i]'
        solver.Si[i] = (CtmpS.L)' \ ((CtmpS.L) \ I(size(solver.Si[i], 1)))
        DDtmp = solver.G[i]' * solver.S[i] * solver.G[i]
        DDtmp = @. (DDtmp + DDtmp') / 2.0
        try
            solver.DDsi[i] = (1.0 ./ sqrt.(diag(DDtmp, 0)))
        catch
            println("WARNING: Numerical difficulties, giving up")
            solver.DDsi[i] = diag(I(size(DDtmp, 1)))
            solver.status = 4
        end
    end
    end

    if solver.model.nlin > 0
        solver.Si_lin = 1.0 ./ solver.S_lin
    else
        solver.Si_lin = []
    end

    return solver.D, solver.G, solver.Gi, solver.W, solver.Si, solver.DDsi, solver.Si_lin

end

using Base.Threads
using LinearAlgebra
using MultiFloats

# Threaded mul! for MultiFloat matrices
function LinearAlgebra.mul!(
        C::Matrix{T},
        A::Matrix{T},
        B::Matrix{T}) where {T <: MultiFloats.MultiFloat}
    m, k = size(A)
    _, n = size(B)
    fill!(C, zero(T))
    @threads for j in 1:n
        for l in 1:k
            @inbounds blj = B[l, j]
            for i in 1:m
                @inbounds C[i, j] += A[i, l] * blj
            end
        end
    end
    return C
end

# Loraine.jl

Loraine.jl is a Julia implementation of an interior point method algorithm for linear semidefinite optimization problems. 

Special features of Loraine:

- Use of an iterative solver for linear systems. This is to be used for problems with (very) low rank solution matrix. Standard (non-low-rank) problems and linear programs can be solved using the direct solver; then the user gets a standard IP method akin SDPT3.
- Use of high-precision arithmetic (by means of MultiFloats.jl). Only to be used with a direct solver (and relatively small problems). *(New in version 0.2.0.)*




## Installation 

Install `Loraine` using `Pkg.add`:
```julia
import Pkg
Pkg.add("Loraine")
```

## Use with JuMP

To use Loraine with JuMP, use `Loraine.Optimizer` (for a standard double-precision solver) or `Loraine.Optimizer{Float64xN}`, with N = 2,...,8 ; for instance:
```julia
using JuMP, Loraine
model = Model(Loraine.Optimizer)
set_attribute(model, "maxit", 100)
```
or, for high-precision arithmetics,
```julia
using JuMP, Loraine
using MultiFloats
model = Model(Loraine.Optimizer{Float64x2})
```
or, for high-precision arithmetics with high-precision input,
```julia
using JuMP, Loraine
using MultiFloats
model = JuMP.GenericModel{Float64x2}(Loraine.Optimizer{Float64x2})
```
To solve an SDP problem stored in SDPA format, do
```julia
using JuMP, Loraine
# using MultiFloats
model = read_from_file("examples/data/theta1.dat-s")
set_optimizer(model, Loraine.Optimizer)
# set_optimizer(model, Loraine.Optimizer{Float64x8})
optimize!(model)
```

## License and Original Contributors

Loraine is licensed under the [MIT License](https://github.com/kocvara/Loraine.jl/blob/main/LICENSE.md).

Loraine was developed by Soodeh Habibi and Michal Kočvara, University of
Birmingham, and Michael Stingl, University of Erlangen, for H2020 ITN POEMA. 

The JuMP interface was provided by Benoît Legat. His help is greatly
acknowledged.

## Citing

If you find Loraine useful, please cite the following paper:
```bibtex
@article{loraine2023,
  title={Loraine-An interior-point solver for low-rank semidefinite programming},
  author={Habibi, Soodeh and Ko{\v{c}}vara, Michal and Stingl, Michael},
  www={https://hal.science/hal-04076509/}
  note={Preprint hal-04076509}
  year={2023}
}
```

# Low-rank solution, more details
In each iteration of the (primal-dual, predictor-corrector) interior-point method we have to solve two systems of linear equations in variable ``y`` with a scaling matrix ``W``:

```math
\begin{equation}
H={\cal A}^T(W\otimes W){\cal A}+ D^T X_{\rm lin}S^{-1}_{\rm lin} D\,.
\end{equation}
```

The complexity of interior point method can be significantly reduced by solving the Schur complement equation ``H y = r`` by an iterative method, rather than Cholesky solver, a standard choice of most IP-based software. 

## Iterative solver

Loraine uses preconditioned conjugate gradient (CG) method.
	
- What can be gained:
    - matrix ``H`` assembly: lower complexity, ``H`` does not have to be stored in memory
    - system ``Hy = r`` can only be solved approximately, one CG iteration has very low complexity (only matrix-vector multiplication)
	
- Drawback:	
    - ``H`` getting (very) ill-conditioned, CG may need very many iterations and may not work at all

*We need a good preconditioner!*

## Low-rank preconditioners for Interior-Point method

### Preconditioner ``H_\alpha`` (`preconditioner = 1`)

Critical observation (due to Richard Y. Zhang and Javad Lavaei, IEEE, 2017) reveals that if the solution ``X^*`` is low-rank then ``W`` will be low-rank.

Hence 
``
W=W_0+UU^T
``
and
```math
H={\cal A}^T(W_0\otimes W_0){\cal A}+{\cal A}^T(U\otimes Z)(U\otimes Z)^T{\cal A}+ D^T X_{\rm lin}S^{-1}_{\rm lin} D\,.
```

This leads to the following preconditioner called ``H_{\alpha}``:
```math
H_{\alpha}={\tau^2 I} +{V}{V}^T+ D^T X_{\rm lin}S^{-1}_{\rm lin} D\,.
```

Here ``V = {\cal A}^T(U\otimes Z)`` has low rank, so we can use Sherman-Morrison-Woodbury formula to compute ``H_{\alpha}^{-1}``.

### Preconditioner ``H_\beta`` (`preconditioner = 2`)
In many problems, the last term in ... is dominating in the first iterations of the IP algorithm, before the low-rank structure of ``W`` is clearly recognized.

This observation lead to the idea of a simplified preconditioner called ``H_\beta`` and defined as follows

```math
\begin{align*}
H_\beta=\tau^2 I+D^\top X_{\text{lin}}S_{\text{lin}}^{-1}D,
\end{align*}
```
in which $\tau$ is defined as in the previous section.
This matrix is easy to invert; in fact, the matrix is diagonal in many problems. It is therefore an extremely cheap preconditioner that is efficient in the first iterations of the IP algorithm.

### Hybrid preconditioner (`preconditioner = 4`)
For relevant problems, we recommend to use a *hybrid preconditioner*: we start the IP iterations with ``H_\beta`` and, once it becomes inefficient, switch to the more expensive but more efficient ``H_\alpha``.  

# Options

The list of Loraine options (default values are in the [bracket]):
```julia
kit             # kit = 0 for direct solver; kit = 1 for CG [0]
tol_cg          # initial tolerance for CG solver [1.0e-2]
tol_cg_up       # tolerance update [0.5]
tol_cg_min      # minimal tolerance for CG solver [1.0e-6]
eDIMACS         # epsilon for DIMACS error stopping criterion [1.0e-5]
preconditioner  # 0...no; 1...H_alpha; 2...H_beta; 4...hybrid [1]
erank           # estimated rank [1]
aamat           # 0..A^TA; 1..diag(A^TA); 2..identity [2]
verb            # 2..full output; 1..short output; 0..no output [1]
datarank        # 0..full rank matrices expected [0]
                # -1..rank-1 matrices expected, converted to vectors, if possible
                # (TBD) 1..vectors expected for low-rank data matrices
initpoint       # 0..Loraine heuristics, 1..SDPT3-like heuristics [0]
timing          # 1..yes, 0..no
maxit           # maximal number of global iterations [200]
datasparsity    # data matrices treated as sparse when number of their 
                # non-zero elements is below this parameter [8]
```

## Comments

- `eDIMACS` is checked against the maximum of [DIMACS errors](https://plato.asu.edu/dimacs/node3.html), measuring (weighted) primal and dual infeasibility, complementary slackness and duality gap.  
    - for the direct solver (`kit = 0`), value about `1e-7` should give a similar precision as default MOSEK
    - for the iterative solver (`kit = 1`), `eDIMACS` may need to be increased to `1e-6` or even `1e-5` to guarantee convergence of Loraine.
    - for the iterative solver (`kit = 1`), `tol_cg_min` should always be smaller than or equal to `eDIMACS`

- `preconditioner`
    - **per CG iteration**, 0 is faster (lower complexity) than 2 which is faster than 1
    - **as a preconditioner**, 1 is better than 2 is better than 0, in the sense of CG iterations needed to solve the linear system
    - some  SDP problems are "easy", meaning that CG always converges without preconditioner (i.e., `preconditioner = 0'), so it's always worth trying this option
    - hybrid (`preconditioner = 4`) starts with (cheaper) `H_beta` and once it gets into difficulties, switches to `H_alpha`

- `erank` (only used when `kit = 1` and `preconditioner > 0`)
    - if you are not sure what the actual rank of the solution is, **always choose** `erank = 1`; with inreasing value of `erank`, the complexity of the preconditioner grows and the whole code could be slower, despite needing fewer CG iterations
    - only if you are sure about the rank of the solution, set `erank` to this value (but you should always compare it to `erank = 1`)

- `datarank` (only used with the direct solver `kit = 0`)
    - choose `datarank = -1` if you know (or suspect) that all the data matrices ``A_i`` have rank one; in this case, the matrices will be factorized as ``A_i = b_i b_i^T`` and vectors ``b_i`` will be used when constructing the Schur complement matrix
    - if you are not sure about the rank of the data matrices, you can always try to set `datarank = -1`; if the factorization of any matrix fails, Lorain will switch to the default option `datarank = 0`
    - for rank-one data matrices, option `datarank = -1` will result in a much faster code than the default `datarank = 0`

- `timing` is not used when Loraine is called from JuMP

- `tol_cg, tol_cg_up, aamat`: it is not recommended to change values of these options, unless you really want to

- `datasparsity` 
    - data matrices treated as sparse when number of their non-zero elements is below `datasparsity` as as    dense otherwise; used when computing the Schur complement matrix
    - when set to zero, all matrices treated as dense
    - set to high number to treat all matrices as sparse
    - recommended setting between 1-16, default value is 8
    - wrong setting can very significantly influence the CPU time

# Low-rank data, more details

Assume that matrices ``A_i`` in ``\sum_{i=1}^{{n}} y_i A_i + S = C,\ \ S\succeq 0,`` are obtained  by
```math
  A_i = B_i B_i^\top
```
with data matrices ``B_i\in{\mathbb R}^{m\times k}`` and with ``k \ll n``.

The complexity of ``H`` assembly is then reduced from ``nm^3`` to ``knm^2``.

*In particular:*
If we know that ``A_i`` have rank one, the decomposition ``A_i = b_i b_i^\top`` is performed by Loraine automatically (`datarank = -1`).

The model is represented internally via the following `struct`:
```@docs
Loraine.MyModel
```

# Loraine - LOw-RAnk INtErior point method
	
Primal-dual predictor-corrector interior-point method together with (optional) iterative solution of the resulting linear systems.
The iterative solver is a preconditioned Krylov-type method with a preconditioner utilizing low rank of the solution.

Loraine is a general purpose SDP solver, particularly suitable for either 

- large-scale SDP problems with low-rank data and/or very-low-rank solutions, or
- difficult small-scale problems where high precision of the solution is required.


## Linear SDP problem
Let's first fix the notation and the problem Lorain atempts to solve.
Consider the primal and the dual linear SDP problem with explicit linear constraints in variables 

```math
\text{primal:}\ X \in \mathbb{S}^m,\ x_{\text{lin}}\in \mathbb{R}^p,\qquad 
\text{dual:}\ y \in \mathbb{R}^n,\ S \in \mathbb{S}^m,\ s_{\text{lin}} \in \mathbb{R}^p
```

and with data

```math
A_i \in \mathbb{S}^m\ (i=1,\ldots,n),\ C \in \mathbb{S}^m,\ c\in{\mathbb R}^n,\ D\in{\mathbb R}^{n\times p},\ d\in{\mathbb R}^p.
```

Primal problem
```math
\begin{equation*}\tag{P}
\begin{aligned}
&\max_{X\in\mathbb{S}^m,\,x_{\text{lin}}\in\mathbb{R}^m~}C \bullet X + d^\top x_{\text{lin}}&\\
&\text{{subject to}}\\ 
&\qquad A_i \bullet X+ (D^\top x_{\text{lin}})_i=b_i\,, \quad i=1,\dots,{n}&\\
&\qquad X\succeq 0,\  x_{\text{lin}}\geq 0& 
\end{aligned}
\end{equation*}
```
Dual problem
```math
		\begin{equation*}\tag{D}
	\begin{aligned}
	& \min_{y\in\mathbb{R}^n,\,S\in\mathbb{S}^m,\,s_{\text{lin}}\in\mathbb{R}^m~} c^\top y \\
	& \text{subject to}\\
	&\qquad \sum_{i=1}^{{n}} y_i A_i + S = C,\ \ S\succeq 0\\
	&\qquad Dy+s_{\text{lin}}=d,\ \ s_{\text{lin}}\geq 0
	\end{aligned}
    \end{equation*}
```


### General assumptions (for the IP algorithm to converge)
Slater constraint qualification and strict complementarity

## Low-rank solution
The following assumptions are only needed when the user want to usilize the iterative solver with the low-rank preconditioner (`kit = 1, preconditioner > 0`). *The assumptions are not needed when using Loraine with the direct solver* (`kit = 0`).

### Assumptions:
Main assumption
- We assume that ``X^*``, the solution of (P)(!!), has very low rank.
	
**Be sure about your problem formulation:** If ``X^*`` has low rank then ``S^*``, the solution of the dual problem, has almost full rank and vice versa. Hence if, in your problem, you assume that ``S^*`` has low rank, you cannot use Loraine with iterative solver directly; rather you may need to dualize your formulation using JuMP's `dualize`.

Further assumptions

- **Sparsity of ``A_i``:** Define the matrix ``{\cal A}=[\text{svec}\,A_1,\dots, \text{svec}\,A_n].`` We assume that matrix-vector products with ``{\cal A}`` and ``{\cal A}^\top`` may each be applied in ``O(n)`` flops and memory.
- **Sparsity of ``D``:** The inverse ``(D^\top D)^{-1}`` and matrix-vector product with ``(D^\top D)^{-1}`` may each be computed in ``\mathcal{O}(n)`` flops and memory.

## Low-rank data
- *At the moment, Loraine can only handle rank-one data.*
- *This feature is only relevant for Loraine used with the **direct solver**.*

If you know (or strongly suspect) that *all* data matrices ``A_i`` have rank one, select the option `datarank = -1`. Loraine will factorize the matrices as ``A_i = b_i b_i^\top`` and use only the vectors ``b_i`` in the interior point algorithm. This will gravely reduce the complexity (and the elapsed time) of Loraine.
